/***********************************************************************************
*
*			Plugin : Point - System
*
*			Author : [A]tomen
*
*			Version : 1.6.2 - 14/10/2008
*
*	Plugin Thread : "http://forums.alliedmods.net/showthread.php?t=74175"
*		
*===================================================================================*
*
*    	  		      Description
*
*			REQ : Amx Mod X >= 1.8.1
*
* Point System, my secondly released plugin. This is a kind of RPG plugin. When you
* kill you receive points stored in a database. You are able to buy different
* benefits and abilities with these points
*
* You receive extra points for headshot, surviving round, win
* round and a lot of more stuff. Everything is fully customized
* with cvars, so you can nearly change everything to fit your needs.
*
* These are the current ones, though I will add more abilities/benefits
* You can access all this in the menu by typing /ps in-game. Menu look
*
* 1. Show Points
* 2. VIP (votekick 7x)
* 3. Custom Player Models
* 4. Mute Rights (5x 2min)
* 5. VIP Mute Rights (5x 10min)
* 6. Start a mapvote
* 7. Reserved Slot 2 weeks
*
* 9. Next
* 0. Exit
*
* If you purchase a custom player model your chosen model will be
* saved in a database so each time you connect you will receive the
* model you have bought. You can easily change models by accessing
* the menu and choose the model. Though it's still at the same cost.
*
* There are 2 saving systems available : FVault and SQLX System
*
*==================================================================================*
*
*			       Credits
*
*	     -Allstars-United	: Created the original idea
*
*	     -Emp		: Great Help with a menu problem
*
*	     -|PJ| Shorty	: Helped me with a 'str_to_num' problem
*
*	     -arkshine		: Optimized my code(x2)
*
*==================================================================================*
*
*	ADMIN Point System Commands	- Console Actions
*
*	ps_add_points <target> <points>		- Adds Points to a Client
*
*	ps_subtract_points <target> <points>	- Subtracts a Clients Points
*
*	ps_ban <target>				- bans a Client from the point_system
*
*	ps_unban <target>			- Unbans a Client from the point_system
*
*	ps_remove_models <target> <team>	- Removes a players custom player models
*
*	ps_give_model <target> <team>		- Give a Custom Player Model
*
*	ps_clean_database [yes|no] <value>	- Delete all entries with '<value>' and below
*
*	ps_reset_database [yes|no]		- Clears the database, requires restart
*
*	ACCESS : ADMIN_PS Define, Default : ADMIN_LEVEL_C
*
*==================================================================================*
*
*	CLIENT Point System Commands	- Say Actions
*
*	/psrank	 - Shows your current point system rank
*
*	/psgive	 - Give away points : <target> <points>
*
*	/points	 - Shows your current amount of points
*
*	/pstop	 - Shows all the players points on the server
*
*	/ps15	 - Shows the players with the highest amount of points
*
*	/pshelp	 - Shows all the point system commands
*
*	/psgp	 - Shows the point system gameplay
*
*	/ps	 - Shows the point system menu
*
*==================================================================================*
*
*		NOTE: To disable a point feature, set the value to 0
*
*	CVARS Miscellaneous Related :
*										    
*	ps_plugin			"1"	// Toggles the plugin on/off
*	ps_advert_time			"120"	// Intervall of the help message
*
*	ps_lan_mode			"0"	// Toggles lan mode on/off (restart server)
*
*	ps_players_required		"3"	// Amount of players required for plugin
*	ps_map_file			"maps"	// List of all maps, maps/mapcycle file.
*
*	ps_time_points			"10"	// Points gained after staying on the server
*	ps_time				"10"	// Minutes needed to stay on the server for bonus
*
*	ps_doublejump_rounds		"1"	// For how many rounds do you have doublejump
*	ps_chameleon_rounds		"1"	// For how many rounds do you have chameleon
*	ps_damage_multiplier_rounds	"3"	// For how many rounds do you have damage multiplier
*
*	ps_reserved_slot_weeks		"2"	// Amount of weeks for 'Reserved Slot' ability
*
*	ps_game_name			"1"	// Turn the game name "Point - System" on/off
*	ps_sound			"1"	// Turn the sounds on/off
*
*==================================================================================*
*
*	CVARS Cost Related :
*
*	ps_vip_cost			"3500"	// Cost for VIP (votekick 7x)
*	ps_doublejump_cost		"350"	// Double Jump Cost
*
*	ps_custom_player_model_cost	"8000"	// Custom Player Model Cost
*	ps_mute_cost			"500"	// Mute Rights Cost (5x 2min)
*
*	ps_mute_vip_cost		"875"	// VIP Mute Rights Cost (5x 10min)
*	ps_mapvote_cost			"800"	// Start a MapVote Cost
*
*	ps_chameleon_cost		"1650"	// Disguised to opposite team cost
*	ps_damage_multiplier_points	"435"	// Damage Multiplier Cost
*
*	ps_reserved_slot_cost		"6500"	// Reserved Slot cost
*
*==================================================================================*
*
*	CVARS Ability Related :
*
*	ps_vip				"1"	// Toggle VIP ability on/off
*	ps_doublejump			"1"	// Toggle doublejump ability on/off
*
*	ps_custom_player_model		"1"	// Toggle CPM ability on/off
*	ps_mute				"1"	// Toggle mute ability on/off
*
*	ps_mute_vip			"1"	// Toggle mute VIP ability on/off
*	ps_mapvote			"1"	// Toggle mapvote ability on/off
*
*	ps_chameleon			"1"	// Toggle Chameleon ability on/off
*	ps_damage_multiplier		"1"	// Toggle Damage Multiplier ability on/off
*
*	ps_reserved_slot		"1"	// Toggle Reserved Slot ability on/off
*
*==================================================================================*
*
*	CVARS Point Related :
*
*	ps_headshot_points		"4"	// Points for a headshot
*	ps_frag_points			"2"	// Points for a kill/frag
*
*	ps_plant_points			"3"	// Points for planting a bomb
*	ps_defuse_points		"3"	// Points for defusing a bomb
*
*	ps_survive_points		"1"	// Points for surviving a round
*	ps_tk_points			"3"	// Amount of Points subtracted on teamkill
*
*	ps_win_points_ct		"2"	// Points for winning a round as CT
*	ps_win_points_t			"2"	// Points for winning a round as T
*
*	ps_mercy_points			"1"	// Amount of Points for "low-pointers"
*	ps_mercy_stop			"300"	// When reached, stops being a "low-pointer"
*
*	ps_vip_frag_points		"5"	// Points for killing a VIP
*	ps_vip_escape_points		"7"	// Points for escaping as a VIP
*
*	ps_vehicle_frag_points		"1"	// Points for killing with a vehicle
*	ps_vehicle_hs_points		"3"	// Points for HS with a vehicle
*
*	ps_hostage_rescue_points	"2"	// Points for Rescuing a hostage
*
*==================================================================================*
*
*	CVARS Left-Overs: The rest of the cvars is in 'ps_cvars.cfg'
*
***********************************************************************************/
#if defined _ps_plugin_included
#endinput
#endif

#define _ps_plugin_included

// Main Includes
#include <amxmodx>
#include <amxmisc>

// Custom Includes
#include <hamsandwich>
#include <fakemeta>

#define SAVE_SQL

#if defined SAVE_SQL
#include <sqlx>
#else
#include <fvault>
#endif

// Reduce the lag
#pragma dynamic		32768
#pragma semicolon	1

#define gPLUGIN		"Point System"
#define gAUTHOR		"[A]tomen"
#define gVERSION	"1.6.2"

#define ADMIN_PS ADMIN_LEVEL_C
//#define DEBUG_MODE

#define MAX_CM_MENUS	11
#define TOP_NUM		15

// Thanks v3x
#define MOTD_LENGTH	1536
#define PLAYER_IS_VIP	(1 << 8)

#define OFFSET_TEAM 	114
#define OFFSET_VIP	209

#define MAX_PLAYERS	32
#define MAX_LENGTH	32

#define MAX_MODELS	48
#define MAX_MAPS	84

#include "ps/variables.inl"	// Variable Stuff
#include "ps/cvars.inl"		// Cvar Related
#include "ps/stocks.inl"	// REQ Functions
#include "ps/data.inl"		// Data Related
#include "ps/commands.inl"	// Commands Related
#include "ps/handles.inl"	// Handle Commands
#include "ps/motds.inl"		// Motd Creation
#include "ps/menus.inl"		// Menu Creation

/*======================================
	  [Plugin - Events]
======================================*/

// Plugin Precache
public plugin_precache()
{
	// Sound effects
	precache_sound(g_sound_add);
	precache_sound(g_sound_subtract);
	precache_sound(g_sound_status);
	
	// Models - Load
	new cfgDir[32];
	get_configsdir(cfgDir, 31);
	
	formatex(filedir3, 255, "%s/ps/models_t.ini", cfgDir);
	formatex(filedir6, 255, "%s/ps/models_ct.ini", cfgDir);
	
	#if defined DEBUG_MODE
	get_logdir(logdir, 255);
	format(logdir, 255, "%s/point_system.log", logdir);
	#endif
	
	new string[66];
	
	formatex(string, 65, "; Point System %s || Model Database TE || Created by %s", gVERSION, gAUTHOR);
	write_file(filedir3, string, 0);
	
	formatex(string, 65, "; Point System %s || Model Database CT || Created by %s", gVERSION, gAUTHOR);
	write_file(filedir6, string, 0);
	
	load_models_ct();
	load_models_t();
	
	for(new i = 0; i < TotalModels_CT; i++)
	{
		if(file_exists(PLMDL_CT[i]))
		{
			precache_model(PLMDL_CT[i]);
			log_ps("Precached %s || Name : %s", PLMDL_CT[i], PLNAME_CT[i]);
		}
	}
	
	for(new i = 0; i < TotalModels_T; i++)
	{
		if(file_exists(PLMDL_T[i]))
		{
			precache_model(PLMDL_T[i]);
			log_ps("Precached %s || Name : %s", PLMDL_T[i], PLNAME_T[i]);
		}
	}
}

// Plugin Natives
public plugin_natives()
{
	register_library("point_system");
	
	register_native("ps_get_user_points",	"native_get_user_points");
	register_native("ps_set_user_points",	"native_set_user_points");
	
	register_native("ps_get_user_status",	"native_get_user_status");
	register_native("ps_set_user_status",	"native_set_user_status");
	
	register_native("ps_get_user_banned",	"native_get_user_banned");
	register_native("ps_set_user_banned",	"native_set_user_banned");
	
	register_native("ps_get_point_rank",	"native_get_point_rank");
	
	register_native("ps_get_user_dj",	"native_get_user_dj");
	register_native("ps_get_user_dm",	"native_get_user_dm");
	register_native("ps_get_user_cm",	"native_get_user_cm");
	register_native("ps_get_user_cpm",	"native_get_user_cpm");
	register_native("ps_get_user_muted",	"native_get_user_muted");
	
	register_native("ps_get_models_loaded",	"native_get_models_loaded");
	register_native("ps_get_model_num",	"native_get_model_num", 1);
	register_native("ps_get_model_name",	"native_get_model_name", 1);
	register_native("ps_get_model_file",	"native_get_model_file", 1);
	
	register_native("ps_print",		"native_print", 1);
	register_native("ps_log",		"native_log", 1);
	
	register_native("ps_add_menu_item",	"native_add_menu_item", 1);
	register_native("ps_update_menu_item",	"native_update_menu_item", 1);
	register_native("ps_remove_menu_item",	"native_remove_menu_item");
}

// Plugin Initialization
public plugin_init()
{
	// Register Plugin
	register_plugin(gPLUGIN, gVERSION, gAUTHOR);
	
	// Message IDs
	g_iMsgAudio	= get_user_msgid("SendAudio");
	g_iMsgHLTV	= get_user_msgid("HLTV");
	
	g_iMsgDeath	= get_user_msgid("DeathMsg");
	g_iMsgSay	= get_user_msgid("SayText");

	g_iMsgHide	= get_user_msgid("HideWeapon");
	g_iMsgCross	= get_user_msgid("Crosshair");
	
	// Events
	g_iHltvID	= register_message(g_iMsgHLTV,	"round_start");
	g_iDeathID	= register_message(g_iMsgDeath,	"fwd_Client_Killed");
	
	g_iMessage	= register_message(g_iMsgAudio,	"round_events");
	g_iDescription	= register_forward(FM_GetGameDescription, "fwd_Game_Desc");
	
	g_iHamDmg	= RegisterHam(Ham_TakeDamage,		"player", "Ham_Client_Damage");
	g_iHamSpawn	= RegisterHam(Ham_Spawn, 		"player", "Ham_Client_Spawn", 1);
	
	g_iHamPost	= RegisterHam(Ham_Player_PostThink,	"player", "Ham_Client_PostThink");
	g_iHamPre	= RegisterHam(Ham_Player_PreThink,	"player", "Ham_Client_PreThink");
	
	g_iKeyValue	= register_forward(FM_SetClientKeyValue,	"fwd_Client_KeyValue");
	g_iThink	= register_forward(FM_Think,			"fwd_Entity_Think");

	register_logevent("fwd_Player_Action", 3,	"1=triggered");
	register_event("30", "event_intermission",	"a");
	
	// Console Commands
	register_concmd("ps_plugin",		"ps_plugin", ADMIN_CVAR, "ps_plugin <1/0>");
	
	register_concmd("ps_add_points",	"ps_add", ADMIN_PS, "<target> <points>");
	register_concmd("ps_subtract_points",	"ps_subtract", ADMIN_PS, "<target> <points>");
	
	register_concmd("ps_ban",		"ps_ban", ADMIN_PS, "<target>");
	register_concmd("ps_unban",		"ps_unban", ADMIN_PS, "<target>");
	
	register_concmd("ps_remove_models",	"ps_remove_models", ADMIN_PS, "<target> <team>");
	register_concmd("ps_give_model",	"ps_give_model", ADMIN_PS, "<target> <team>");
	
	register_concmd("ps_clean_database",	"ps_clean_db", ADMIN_PS, "[yes|no] <points>");
	register_concmd("ps_reset_database",	"ps_reset_db", ADMIN_PS, "[yes|no]");
	
	// Open Menu - Console
	register_clcmd("ps_menu", "points_menu");
	
	// Custom Forwards
	g_fwd_menu_creation	= CreateMultiForward("ps_user_menu_creation", ET_CONTINUE, FP_CELL);
	g_fwd_menu_selection	= CreateMultiForward("ps_user_menu_selection", ET_CONTINUE, FP_CELL, FP_CELL);
	
	g_fwd_points_pre	= CreateMultiForward("ps_user_points_pre", ET_CONTINUE, FP_CELL, FP_CELL, FP_CELL);
	g_fwd_points_post	= CreateMultiForward("ps_user_points_post", ET_CONTINUE, FP_CELL, FP_CELL, FP_CELL);
	
	g_fwd_status_pre	= CreateMultiForward("ps_user_status_pre", ET_CONTINUE, FP_CELL, FP_CELL, FP_CELL);
	g_fwd_status_post	= CreateMultiForward("ps_user_status_post", ET_CONTINUE, FP_CELL, FP_CELL, FP_CELL);
	
	// Say Commands
	register_clcmd("say_team",		"check_say");
	register_clcmd("say",			"check_say");
	
	// Miscellaneous
	register_dictionary("point_system.txt");
	cvar_initialization();
}

// Plugin Configuration
public plugin_cfg()
{
	// Format File Locations
	new cfgDir[64], ps_cfg[128];
	get_configsdir(cfgDir, 63);
	
	formatex(filedir4, 255, "%s/ps/ps_help.txt", cfgDir);
	formatex(ps_cfg, 127, "%s/ps/ps_cvars.cfg", cfgDir);
	
	// Load the Cvars
	if(file_exists(ps_cfg))
	{
		server_cmd("exec %s", ps_cfg);
		server_exec();
	}
	
	#if defined SAVE_SQL
	// Open SQL Connection
	new host[64], user[64], pass[64], db[64], g_cache[512];
	
	get_cvar_string("ps_sql_host", host, 63);
	get_cvar_string("ps_sql_user", user, 63);
	get_cvar_string("ps_sql_pass", pass, 63);
	get_cvar_string("ps_sql_db", db, 63);
	
	g_SqlTuple = SQL_MakeDbTuple(host, user, pass, db);
	
	if(!g_SqlTuple) { set_fail_state("[PS] Could not connect to the database, check your cvars") ; }
	
	else
	{
		new data[2];
		
		data[0] = LOAD_NONE;
		data[1] = 0;
		
		formatex(g_cache, 511, "CREATE TABLE IF NOT EXISTS `%s` (`steamid` VARCHAR(32) NOT NULL default '', `name` VARCHAR(32) NOT NULL default '', `points` INT(11) NOT NULL default '0', `status` VARCHAR(32) NOT NULL default '', PRIMARY KEY(`steamid`));", g_table);
		SQL_ThreadQuery(g_SqlTuple, "sql_public_handle", g_cache, data, 2);
	}
	#endif
	
	// Plugin Help/Advertisment
	set_pcvar_float(ps_adv_time, floatclamp(get_pcvar_float(ps_adv_time), 50.0, 250.0));
	set_task(get_pcvar_float(ps_adv_time), "fwd_adv_help", _, _, _, "b");
	
	// Add Client Menu Item
	AddMenuItem_call("Open PS Menu", "ps_menu", ADMIN_USER, gPLUGIN, true);
	
	// Motd Time
	if(get_pcvar_num(ps_motd))
	{
		server_cmd("mp_chattime 18");
	}
}

/*======================================
	[Connection - Events]
======================================*/

// Player In - Server
public client_putinserver(id)
{
	if(g_iPlugin && g_iPlayers == get_pcvar_num(ps_players))
	{
		point_print(0, "%L", LANG_SERVER, "POINT_PLAYERS_ON");
		g_bShown = false;
	}
	
	if(!g_info[id][0])
	{
		switch(get_pcvar_num(ps_lan_mode))
		{
			case 0: get_user_authid(id, g_info[id], MAX_LENGTH);
			case 1: get_user_name(id, g_info[id], MAX_LENGTH);
		}
		
		get_data(id);
	}
	
	gb_user_connected[id] = true;
}

// Player Authorized
public client_authorized(id)
{
	g_iPlayers++;
	
	if(is_ps_on())
	{
		switch(get_pcvar_num(ps_lan_mode))
		{
			case 0: get_user_authid(id, g_info[id], MAX_LENGTH);
			case 1: get_user_name(id, g_info[id], MAX_LENGTH);
		}
		
		get_data(id);
		
		if(get_pcvar_num(ps_cpm))
		{
			g_cpm_t[id]	= g_status[id][1] > 0 ? true : false;
			g_cpm_ct[id]	= g_status[id][5] > 0 ? true : false;
		}
		
		jump_num[id]	= false;
		do_jump[id]	= false;
	}
}

// Player Disconnect
public client_disconnect(id)
{
	g_iPlayers--;
	
	if(g_iPlayers == (get_pcvar_num(ps_players) - 1) && !g_bShown)
	{
		point_print_spc(0, "%L", LANG_SERVER, "POINT_PLAYERS_OFF");
		g_bShown = true;
	}
	
	if(g_iPlugin) set_data(id);
	
	if(is_ps_on())
	{
		jump_num[id]	= false;
		do_jump[id]	= false;
		
		g_cpm_ct[id]	= false;
		g_cpm_t[id]	= false;
		
		muted[id]	= false;
		
		#if defined SAVE_SQL
		g_exists[id]	= false;
		#endif
	}
	
	gb_user_connected[id]	= false;
	gb_user_alive[id]	= false;
}

/*======================================
[Misc - Events]
======================================*/

// Player Death
public fwd_Client_Killed()
{
	if(is_ps_on())
	{
		new attacker	= get_msg_arg_int(1);
		new victim	= get_msg_arg_int(2);
		
		gb_user_alive[victim] = false;
		
		if(gb_user_connected[attacker] && get_pcvar_num(ps_frags_on))
		{
			// No need for 'CsTeams:', Custom Stocks
			new FmTeams:team_1	= fm_get_user_team(attacker);
			new FmTeams:team_2	= fm_get_user_team(victim);
			
			if(team_1 != team_2)
			{
				static weapon[MAX_LENGTH + 1];
				get_msg_arg_string(4, weapon, MAX_LENGTH);
				
				ucfirst(weapon);
				
				if(fm_get_user_vip(victim) && get_pcvar_num(ps_asa))
				{
					new status = get_pcvar_num(ps_asa);
					update_points(attacker, status, _, 1);
					
					point_print(attacker, "%L", attacker, "POINT_RECEIVED", "VIP Kill : ", status);
				}
				
				else if(equali(weapon, "grenade") && get_pcvar_num(frag_kl[CSW_HEGRENADE]))
				{
					new status_1	= get_pcvar_num(frag_kl[CSW_HEGRENADE]);
					new status_2	= get_pcvar_num(frag_hs[CSW_HEGRENADE]);
					
					new headshot	= get_msg_arg_int(3);
					
					if(!headshot) add(weapon, MAX_LENGTH, "-Kill : ");
					else add(weapon, MAX_LENGTH, "-HS : ");
					
					update_points(attacker, headshot ? status_2 : status_1, _, 1);
					point_print(attacker, "%L", attacker, "POINT_RECEIVED", weapon, headshot ? status_2 : status_1);
				}
				
				else if(equali(weapon, "vehicle") || equali(weapon, "tank") && get_pcvar_num(ps_vehicle_points))
				{
					new status_1	= get_pcvar_num(ps_vehicle_points);
					new status_2	= get_pcvar_num(ps_vehicle_hs);
					
					new headshot	= get_msg_arg_int(3);
					
					if(!headshot) add(weapon, MAX_LENGTH, "-Kill : ");
					else add(weapon, MAX_LENGTH, "-HS : ");
					
					update_points(attacker, headshot ? status_2 : status_1, _, 1);
					point_print(attacker, "%L", attacker, "POINT_RECEIVED", weapon, headshot ? status_2 : status_1);
				}
				
				else
				{
					new csw_wpn	= get_user_weapon(attacker);
					
					new status_1	= get_pcvar_num(frag_hs[csw_wpn]);
					new status_2	= get_pcvar_num(frag_kl[csw_wpn]);
					
					if(status_2)
					{
						new headshot = get_msg_arg_int(3);
						
						if(status_1 && headshot)
						{
							add(weapon, MAX_LENGTH, "-HS : ");
							
							update_points(attacker, status_1, _, 1);
							point_print(attacker, "%L", attacker, "POINT_RECEIVED", weapon, status_1);
						}
						
						else if(status_2)
						{
							add(weapon, MAX_LENGTH, "-Kill : ");
							
							update_points(attacker, status_2, _, 1);
							point_print(attacker, "%L", attacker, "POINT_RECEIVED", weapon, status_2);
						}
					}
				}	
			}
			
			else if(get_pcvar_num(ps_tk) && attacker != victim)
			{
				new status	=	get_pcvar_num(ps_tk_points);
				
				point_print(attacker, "%L", attacker, "POINT_SUBTRACT", status);
				update_points(attacker, status, 0, 1);
			}
		}
	}
	
	return 0;
}

public fwd_Player_Action()
{
	if(is_ps_on())
	{
		static arg[64], action[64];
		static name[MAX_LENGTH + 1];

		new userid, id;

		read_logargv(0, arg, 63);
		read_logargv(2, action, 63);

		parse_loguser(arg, name, 63, userid);
		id = find_player("k", userid);

		if(!id)
			return;

		if(equal(action, "Rescued_A_Hostage") && get_pcvar_num(ps_res_points) > 0)
		{
			new status = get_pcvar_num(ps_res_points);

			point_print(id, "%L", id, "POINT_RESCUED", status, status > 1 ? "s" : "");
			update_points(id, status, _, 1);
		}

		else if(equal(action, "Escaped_As_VIP") && get_pcvar_num(ps_esc_points) > 0)
		{
			new status = get_pcvar_num(ps_esc_points);

			point_print(id, "%L", id, "POINT_ESCAPE", status, status > 1 ? "s" : "");
			update_points(id, status, _, 1);
		}

		else if(equal(action, "Defused_The_Bomb") && get_pcvar_num(ps_def_points) > 0)
		{
			new status = get_pcvar_num(ps_def_points);

			point_print(id, "%L", id, "POINT_DEFUSED", status, status > 1 ? "s" : "");
			update_points(id, status, _, 1);
		}

		else if(equal(action, "Planted_The_Bomb") && get_pcvar_num(ps_plt_points) > 0)
		{
			new status = get_pcvar_num(ps_plt_points);

			point_print(id, "%L", id, "POINT_PLANTED", status, status > 1 ? "s" : "");
			update_points(id, status, _, 1);
		}
	}
}

public fwd_Game_Desc()
{
	if(is_ps_on() && get_pcvar_num(ps_game_name))
	{
		forward_return(FMV_STRING, gPLUGIN);
		return FMRES_SUPERCEDE;
	}
	
	return FMRES_IGNORED;
}

public fwd_Client_KeyValue(id, const infobuffer[], const key[])
{
	new FmTeams:team = fm_get_user_team(id);
	
	if(do_chameleon[id] || team == FM_TEAM_CT && g_cpm_ct[id] || team == FM_TEAM_T && g_cpm_t[id] && equal(key, "model"))
		return FMRES_SUPERCEDE;
	
	return FMRES_IGNORED;
}

public event_intermission()
{
	// Thanks Avalanche
	message_begin(MSG_ALL, SVC_FINALE);
	write_string("");
	message_end();

	message_begin(MSG_ALL, g_iMsgHide);
	write_byte((1<<0)|(1<<1)|(1<<3)|(1<<4)|(1<<5)|(1<<6));
	message_end();
	
	message_begin(MSG_ALL, g_iMsgCross);
	write_byte(0);
	message_end();

	new pcvar = get_pcvar_num(ps_motd);

	for(new i = 1; i <= g_maxplayers; i++)
	{
		if(gb_user_connected[i])
		{
			if(pcvar)
			{
				format_end_motd(i);
			}

			set_data(i);
		}
	}

	#if !defined SAVE_SQL
	new dir[64];
	formatex(dir, 63, "%s/temp_ps_vault.txt", _vault_dir);
	
	if(file_exists(dir)) delete_file(dir);
	#endif
	
	g_intermission = true;
}

public plugin_end()
{
	if(!g_intermission)
	{
		for(new i = 1; i <= g_maxplayers; i++)
		{
			if(gb_user_connected[i])
			{
				set_data(i);
			}
		}
	}

	#if defined SAVE_SQL
	SQL_FreeHandle(g_SqlTuple);
	#else

	new dir[64];
	formatex(dir, 63, "%s/temp_ps_vault.txt", _vault_dir);
	
	if(file_exists(dir)) delete_file(dir);
	#endif
}

/*======================================
	   [Ham - Events]
======================================*/

public Ham_Client_Spawn(id)
{
	if(is_ps_on() && is_user_alive(id))
	{
		gb_user_alive[id] = true;
		
		if(g_banned[id] && !g_banned_shwn[id])
		{
			client_print(id, print_chat, "%L", id, "POINT_BANNED");
			return HAM_IGNORED;
		}
		
		new check_false = is_false_user(id);
		new check = get_pcvar_num(ps_mcy_points);
		
		if(check > 0 && !g_round_ended[id] && !check_false)
		{
			if(g_points[id] < get_pcvar_num(ps_mcy_stop))
			{
				g_round_ended[id] = true;
				
				point_print(id, "%L", id, "POINT_RECEIVED", "Mercy Points: ", check);
				update_points(id, check, _, 1);
			}
		}
		
		g_cpm_t[id]	= g_status[id][1] > 0 ? true : false;
		g_cpm_ct[id]	= g_status[id][5] > 0 ? true : false;
		
		if(g_cpm_ct[id] && fm_get_user_team(id) == FM_TEAM_CT && !check_false)
		{
			new model[MAX_LENGTH + 1], current[64];
			new num = g_status[id][5], team = 2;
			
			get_user_model(num, model, MAX_LENGTH, team);
			fm_get_user_model(id, current, 63);
			
			if(!equali(current, model))
				fm_set_user_model(id, model);
		}
		
		else if(g_cpm_t[id] && fm_get_user_team(id) == FM_TEAM_T && !check_false)
		{
			new model[MAX_LENGTH + 1], current[64];
			new num = g_status[id][1], team = 1;
			
			get_user_model(num, model, MAX_LENGTH, team);
			fm_get_user_model(id, current, 63);
			
			if(!equali(current, model))
				fm_set_user_model(id, model);
		}
		
		if(g_ChameRend[id])
			set_task(0.5, "chameleon", id);
		
		set_task(7.5, "check_time", id);
	}
	
	return HAM_IGNORED;
}

public Ham_Client_Damage(victim, inflictor, attacker, Float:damage, damagebits)
{
	if(is_ps_on() && 1 <= attacker <= g_maxplayers && gb_user_connected[victim] && g_DamageRend[attacker])
	{
		SetHamParamFloat(4, damage * 2.0);
		return HAM_HANDLED;
	}
	
	return HAM_IGNORED;
}

public Ham_Client_PreThink(id)
{
	if(!gb_user_alive[id] || !g_DoubleRend[id] || !is_ps_on()) return 0;
	
	new nbut = pev(id, pev_button);
	new obut = pev(id, pev_oldbuttons);
	
	if((nbut & IN_JUMP) && !(pev(id, pev_flags) & FL_ONGROUND) && !(obut & IN_JUMP))
	{
		if(jump_num[id] < 1)
		{
			do_jump[id] = true;
			jump_num[id]++;
			
			return 0;
		}
	}
	
	if((nbut & IN_JUMP) && (pev(id, pev_flags) & FL_ONGROUND))
	{
		jump_num[id] = 0;
		return 0;
	}
	
	return 0;
}

public Ham_Client_PostThink(id)
{
	if(!gb_user_alive[id] || !g_DoubleRend[id] || !is_ps_on()) return 0;
	
	if(do_jump[id])
	{
		new Float:velocity[3];
		pev(id, pev_velocity, velocity);
		
		velocity[2] = random_float(265.0, 285.0);
		set_pev(id, pev_velocity, velocity);
		
		do_jump[id] = false;
		return 0;
	}
	
	return 0;
}

/*======================================
[Plugin Natives]
======================================*/

// ps_get_user_points(id)
public native_get_user_points()
{
	return g_points[get_param(1)];
}

// ps_set_user_points(id, amount, status, sound)
public native_set_user_points()
{
	update_points(get_param(1), get_param(2), get_param(3), get_param(4));
}

// ps_get_user_status(id, status)
public native_get_user_status()
{
	return g_status[get_param(1)][get_param(2) - 1];
}

// ps_set_user_status(id, status, value, sound)
public native_set_user_status()
{
	change_status(get_param(1), get_param(2), get_param(3), get_param(4));
}

// ps_get_user_banned(id)
public native_get_user_banned()
{
	return g_banned[get_param(1)];
}

// ps_set_user_banned(id, access)
public native_set_user_banned()
{
	new id = get_param(1);
	
	switch(get_param(2))
	{
		case 0: g_banned[id] = false;
		case 1: g_banned[id] = true;
	}
}

// ps_get_point_rank(id)
public native_get_point_rank()
{
	new id = get_param(1);
	
	#if defined SAVE_SQL
	new data[2], sql[512];
	
	data[0] = LOAD_RANKING;
	data[1] = id;
	
	formatex(sql, 511, "SELECT `steamid`, `points` FROM `%s` ORDER BY `points` DESC", g_table);
	return SQL_ThreadQuery(g_SqlTuple, "sql_public_handle", sql, data, 2);
	#else
	new key[38];
	formatex(key, 37, "%s-PS", g_info[id]);
	
	return (fvault_get_keynum(g_points_vault, key) + 1);
	#endif
}

// ps_get_user_dj(id)
public native_get_user_dj()
{
	new id = get_param(1);
	
	if(g_DoubleRend[id] || g_DoubleUsed[id])
		return 1;
	
	return 0;
}

// ps_get_user_dm(id)
public native_get_user_dm()
{
	new id = get_param(1);
	
	if(g_DamageRend[id] || g_DamageUsed[id])
		return 1;
	
	return 0;
}

// ps_get_user_cm(id)
public native_get_user_cm()
{
	new id = get_param(1);
	
	if(g_ChameRend[id] || do_chameleon[id])
		return 1;
	
	return 0;
}

// ps_get_user_cpm(id, team)
public native_get_user_cpm()
{
	new id = get_param(1);
	
	switch(get_param(2))
	{
		case 1: if(g_cpm_t[id])		{ return 1; }
		case 2: if(g_cpm_ct[id])	{ return 1; }
	}
	
	return 0;
}

// ps_get_user_muted(id)
public native_get_user_muted()
{
	new id = get_param(1);
	
	if(muted[id] || g_status[id][4])
		return 1;
	
	return 0;
}

// ps_get_models_loaded(team)
public native_get_models_loaded()
{
	switch(get_param(1))
	{
		case 0: return (TotalModels_T += TotalModels_CT);
		case 1: return TotalModels_T;
		case 2: return TotalModels_CT;
	}
	
	return -1;
}

public native_get_model_num(const model[], team)
{
	param_convert(1);
	
	return get_model_num(model, get_param(2));
}

public native_get_model_name(num, string[], len, team)
{
	param_convert(2);
	
	get_user_model(num, string, len, team);
	return string;
}

public native_get_model_file(const model_name[], file[], len, team)
{
	param_convert(1);
	param_convert(2);
	
	get_model_file(model_name, file, len, team);
	return file;
}

public native_print(id, fmt[], any:...)
{
	if(id && !gb_user_connected[id] || !is_ps_on()) return 0;
	
	param_convert(2);
	
	new MSG_TYPE, index;
	static finalmsg[192];
	
	vformat(finalmsg, 191, fmt, 3);
	format(finalmsg, 191, "^x04[PS] ^x01%s", finalmsg);
	
	if(id)
	{
		MSG_TYPE	=	MSG_ONE;
		index		=	id;
	}
	
	else
	{
		MSG_TYPE	=	MSG_ALL;
		index		=	find_players();
	}
	
	message_begin(MSG_TYPE, g_iMsgSay, _, id);
	write_byte(index);
	write_string(finalmsg);
	message_end();
	
	return 1;
}

public native_log(fmt[], any:...)
{
	param_convert(1);
	
	static msg[192];
	vformat(msg, 191, fmt, 2);
	
	format(msg, 191, "%s", msg);
	
	#if defined DEBUG_MODE
	if(!equali(msg, ";"))
		write_file(logdir, msg, -1);
	#endif
}

public native_add_menu_item(const text[], unique_id)
{
	param_convert(1);
	
	if(!text[0])
		return 0;
	
	if(g_custom_menus_num)
	{
		for(new i = 0; i < g_custom_menus_num; i++)
		{
			if(equal(text, g_custom_menus[i]) || unique_id == g_custom_menu_id[i])
				return -1;
			
			else if(!g_custom_menus[i][0])
			{
				formatex(g_custom_menus[i], 127, "%s", text);
				
				g_custom_menu_id[i] = unique_id;
				g_custom_menus_num++;
				
				return 1;
			}
		}
		
		if(g_custom_menus_num < MAX_CM_MENUS)
		{
			formatex(g_custom_menus[g_custom_menus_num], 127, "%s", text);
			
			g_custom_menu_id[g_custom_menus_num] = unique_id;
			g_custom_menus_num++;
			
			return 1;
		}
	}
	
	else
	{
		formatex(g_custom_menus[0], 127, "%s", text);
		
		g_custom_menu_id[0] = unique_id;
		g_custom_menus_num++;
		
		return 1;
	}
	
	return 0;
}

public native_update_menu_item(unique_id, const text[])
{
	param_convert(2);
	
	if(!text[0])
		return 0;
	
	if(g_custom_menus_num)
	{
		for(new i = 0; i < g_custom_menus_num; i++)
		{
			if(unique_id == g_custom_menu_id[i])
			{
				formatex(g_custom_menus[i], 127, "%s", text);
				return 1;
			}
		}
		
		return -1;
	}
	
	else
	return -1;
	
	return 0;
}

public native_remove_menu_item(unique_id)
{
	if(!unique_id || !g_custom_menus_num) return 0;
	
	new sum = g_custom_menus_num - 1;
	
	if(unique_id == g_custom_menu_id[sum])
	{
		formatex(g_custom_menus[sum], 127, "");
		
		g_custom_menu_id[sum] = 0;
		g_custom_menus_num--;
		
		return 1;
	}
	
	else
	{
		new bool:has_found;
		
		for(new i = 0; i < g_custom_menus_num; i++)
		{
			if(unique_id == g_custom_menu_id[i])
				has_found = true;
			
			else if(has_found)
			{
				new x = i - 1;
				
				formatex(g_custom_menus[x], 127, "%s", g_custom_menus[i]);
				g_custom_menu_id[x] = g_custom_menu_id[i];
			}
		}
		
		if(has_found) { g_custom_menus_num--; return 1; }
	}
	
	return -1;
}

/*======================================
[Round - Events]
======================================*/

public round_start()
{
	if(is_ps_on())
	{
		static message[2];
		
		message[0] = get_msg_arg_int(1);
		message[1] = get_msg_arg_int(2);
		
		// Round - Start
		if(!message[0] && !message[1])
		{
			for(new i = 1; i <= g_maxplayers; i++)
			{
				if(gb_user_connected[i] && gb_user_alive[i])
				{
					if(g_DoubleJump[i])
					{
						g_DoubleJump[i]	= false;
						g_DoubleUsed[i] = false;
						
						g_DoubleRend[i] = true;
					}
					
					if(g_Chameleon[i])
					{
						g_Chameleon[i]	= false;
						do_chameleon[i]	= false;
						
						g_ChameRend[i]	= true;
					}
					
					if(g_DamageMult[i])
					{
						g_DamageMult[i] = false;
						g_DamageUsed[i] = false;
						
						g_DamageRend[i] = true;
					}
				}
			}
		}
	}
}

public round_events()
{
	if(is_ps_on() && get_msg_args() == 3)
	{
		new status, FmTeams:team;
		
		static message[MAX_LENGTH + 1];
		get_msg_arg_string(2, message, MAX_LENGTH);
		
		switch(message[7])
		{
			// Message == "%!MRAD_terwin"
			case 't':
			{
				if(message[8] == 'e')
				{
					status = get_pcvar_num(ps_win_points_t);
					team = FM_TEAM_T;
				}
			}
			
			// Message == "%!MRAD_ctwin"
			case 'c':
			{
				if(message[8] == 't')
				{
					status = get_pcvar_num(ps_win_points_ct);
					team = FM_TEAM_CT;
				}
			}
			
			// Message == "%!MRAD_rounddraw"
			case 'r':
			{
				if(message[8] == 'o')
				{
					status = -1;
					team = FM_TEAM_UNASSIGNED;
				}
			}
			
			default: { return; }
		}
		
		if(status)
		{
			arrayset(g_round_ended, false, MAX_PLAYERS + 1);
			new points = get_pcvar_num(ps_sur_points);

			for(new i = 1; i <= g_maxplayers; i++)
			{
				if(gb_user_connected[i])
				{
					if(status != -1 && fm_get_user_team(i) == team)
					{
						point_print(i, "%L", i, "POINT_RECEIVED", "Round Won : ", status);
						update_points(i, status, _, 1);
					}

					if(gb_user_alive[i] && points > 0)
					{
						point_print(i, "%L", i, "POINT_RECEIVED", "Survived Round : ", points);
						update_points(i, points, _, 1);
					}

					if(g_DoubleRend[i])
					{
						g_DoubleUsed[i]++;
					
						if(g_DoubleUsed[i] >= get_pcvar_num(ps_dj_rounds))
						{
							g_DoubleUsed[i] = false;
							g_DoubleRend[i] = false;
						}
					}
				
					if(g_ChameRend[i])
					{
						do_chameleon[i]++;
					
						if(do_chameleon[i] >= get_pcvar_num(ps_cm_rounds))
						{
							do_chameleon[i] = false;
							g_ChameRend[i]	= false;
						}
					}
				
					if(g_DamageRend[i])
					{
						g_DamageUsed[i]++;
					
						if(g_DamageUsed[i] >= get_pcvar_num(ps_dm_rounds))
						{
							g_DamageUsed[i] = false;
							g_DamageRend[i] = false;
						}
					}
				}
			}
		}
	}
}

/*======================================
	  [Miscellaneous]
======================================*/

public fwd_adv_help()
{
	if(is_ps_on())
	{
		// Show Information
		point_print_spc(0, "%L", LANG_PLAYER, "POINT_INFO_1", gPLUGIN, gVERSION, gAUTHOR);
		point_print_spc(0, "%L", LANG_PLAYER, "POINT_INFO_2");
		point_print_spc(0, "%L", LANG_PLAYER, "POINT_INFO_3");
	}
}

public chameleon(id)
{
	switch(fm_get_user_team(id))
	{
		case FM_TEAM_T : fm_set_user_model(id, g_HumanModels_T [random_num(0, 3)]);
		case FM_TEAM_CT: fm_set_user_model(id, g_HumanModels_CT[random_num(0, 3)]);
	}
	
	if(!gcm_shown[id])
	{
		point_print(id, "%L", id, "POINT_ENEMY");
		gcm_shown[id] = true;
	}
}

/*======================================
	      [Checks]
======================================*/

public check_time(id)
{
	new status	=	get_pcvar_num(ps_time_points);
	new time	=	get_pcvar_num(ps_time);
	
	if(!g_played_times[id])
		g_played_times[id] = 1;
	
	if(get_user_time(id, true) >= ((time * 60) * g_played_times[id]) && status > 0)
	{
		point_print(id, "%L", id, "POINT_TIME", (time * g_played_times[id]), status);
		update_points(id, status, _, 1);
		
		g_played_times[id]++;
	}
	
	if(g_status[id][6])
	{
		new time = (g_status[id][6] - get_systime_h());
		
		if(time <= 0)
		{
			point_print(id, "%L", id, "POINT_ENDED");
			change_status(id, 7, 0);
			
			ps_edit_admin(g_info[id], _, "b", _, _, 1);
			remove_user_flags(id, ADMIN_RESERVATION);
		}
	}
}

public check_say(id)
{
	if(is_ps_on() && gb_user_connected[id])
	{
		new current = g_status[id][4];
		static szSaid[32];
		
		read_args(szSaid, 31);
		remove_quotes(szSaid);
		
		if(current && !muted[id])
			muted[id] = true;
		
		if(szSaid[0] == '.' || szSaid[0] == '/')
		{
			if(szSaid[1] == 'p' && szSaid[2] == 's')
			{
				if(szSaid[3] == 'h' && szSaid[4] == 'e')
				{
					show_help_motd(id);
				}
				
				else if(szSaid[3] == 'r' && szSaid[4] == 'a')
				{
					show_rank(id);
				}
				
				else if(szSaid[3] == 'g' && szSaid[4] == 'p')
				{
					show_gp_motd(id);
				}
				
				else if(szSaid[3] == 't' && szSaid[4] == 'o')
				{
					show_top_points(id);
				}
				
				else if(szSaid[3] == '1' && szSaid[4] == '5')
				{
					show_top_players(id);
				}
				
				else if(szSaid[3] == 'g' && szSaid[4] == 'i')
				{
					static dummy[12], arg[2][MAX_LENGTH + 1];
					parse(szSaid, dummy, 11, arg[0], MAX_LENGTH, arg[1], MAX_LENGTH);
					
					log_amx("ARG[0]: %s", arg[0]);
					
					new target = cmd_target(id, arg[0], CMDTARGET_ALLOW_SELF);
					static name[2][MAX_LENGTH + 1];
					
					get_user_name(id, name[0], MAX_LENGTH);
					get_user_name(target, name[1], MAX_LENGTH);
					
					if(!arg[0][0] || equali(szSaid, "/psgive") || equali(szSaid, ".psgive"))
					{
						point_print(id, "%L", id, "ADMIN_GIVE_USAGE");
					}
					
					else if(!target)
					{
						point_print(id, "%L", id, "ADMIN_NONE_PLAYER", arg[0]);
					}
					
					else if(g_banned[target])
					{
						point_print(id, "%L", id, "ADMIN_ARE_BANNED", name[1]);
					}
					
					else if(!isdigit(arg[1][0]))
					{
						point_print(id, "%L", id, "ADMIN_WRONG_VALUE", arg[1]);
					}
					
					else
					{
						new amount = str_to_num(arg[1]);
						
						if(g_points[id] < amount)
						{
							point_print(id, "%L", id, "POINT_TO_LOW", g_points[id], amount);
							return get_pcvar_num(ps_hide) ? 1 : 0;
						}
						
						else if(amount <= 0)
						{
							point_print(id, "%L", id, "POINT_NULL");
							return get_pcvar_num(ps_hide) ? 1 : 0;
						}
						
						point_print(id, "%L", id, "POINT_GAVE", name[1], amount);
						
						update_points(id, amount, 0);
						point_print(id, "%L", id, "POINT_CURRENT", g_points[id]);
						
						point_print(target, "%L", target, "POINT_GIVEN", name[0], amount);
						
						update_points(target, amount, _, 1);
						point_print(target, "%L", target, "POINT_CURRENT", g_points[target]);
					}
				}
				
				else
				{
					show_points_menu(id);
				}
			}
			
			else if(szSaid[1] == 'p' && szSaid[2] == 'o' && szSaid[3] == 'i')
			{
				show_points(id);
			}
			
			return get_pcvar_num(ps_hide) ? 1 : 0;
		}
		
		new time = (get_systime() / 60);
		
		if(muted[id] && time < current)
		{
			static g_say_words[14][24] =
			{
				"/psranks",
				".psranks",
				"/psrank",
				".psrank",
				"/points",
				".points",
				"/psgive",
				".psgive",
				"/ps15",
				".ps15",
				"/pshelp",
				".pshelp",
				"/ps",
				".ps"
			};
			
			static const g_listsize = sizeof(g_say_words);
			
			for(new i; i < g_listsize; i++)
			{
				if(equali(szSaid, g_say_words[i]))
					return get_pcvar_num(ps_hide) ? 1 : 0;
			}
			
			new left = (current - time);
			point_print(id, "%L", id, "POINT_MUTED_1", left);
			
			return 1;
		}
		
		else if(muted[id] && time >= current)
		{
			point_print(id, "%L", id, "POINT_MUTED_2");
			change_status(id, 5, 0);
			
			muted[id] = false;
		}
	}
	
	return 0;
}