/*======================================
	     [Admin PS File]
======================================*/

public ps_add(id, level, cid)
{
	if(!cmd_access(id, level, cid, 3))
		return 1;

	if(!is_ps_on())
	{
		client_print(id, print_console, "%L", id, "POINT_DISABLED");
		return 1;
	}

	new arg1[24];
	new arg2[12];

	read_argv(1, arg1, 23);
	read_argv(2, arg2, 11);

	new points = str_to_num(arg2);

	if(arg1[0] == '@')
	{
		new bool:g_shown;
		static team;

		switch(arg1[1])
		{
			case 'T' : team = 1;
			case 'C' : team = 2;
		}

		static info[2][MAX_LENGTH + 1];

		if(get_pcvar_num(ps_lan_mode))
		{
			get_user_authid(id, info[1], MAX_LENGTH);
			info[0] = g_info[id];
		}

		else
		{
			get_user_name(id, info[0], MAX_LENGTH);
			info[1] = g_info[id];
		}

		for(new i = 1; i <= g_maxplayers; i++)
		{
			if(!team && !is_false_user(id))
			{
				update_points(i, points, _, 1);

				if(!g_shown)
				{
					switch(get_pcvar_num(ps_show))
					{
						case 1: point_print(0, "%L", LANG_PLAYER, "ADMIN_NOTE_EVERYONE_1A", points);
						case 2: point_print(0, "%L", LANG_PLAYER, "ADMIN_NOTE_EVERYONE_2A", info[0], points);
					}

					console_print(id, "%L", id, "ADMIN_EVERYONE_1A", points);
					log_amx("%L", LANG_SERVER, "ADMIN_EVERYONE_2A", info[0], info[1], points);

					g_shown = true;
				}
			}

			else
			{
				if(get_user_team(i) == team && !is_false_user(id))
				{
					update_points(i, points, _, 1);
					static string[24];

					if(!g_shown)
					{
						switch(team)
						{
							case 1: formatex(string, 23, "Terrorists");
							case 2: formatex(string, 23, "Counter-Terrorists");
						}

						switch(get_pcvar_num(ps_show))
						{
							case 1: point_print(0, "%L", LANG_PLAYER, "ADMIN_NOTE_TEAM_1A", string, points);
							case 2: point_print(0, "%L", LANG_PLAYER, "ADMIN_NOTE_TEAM_2A", info[0], string, points);
						}

						static steamid[MAX_LENGTH + 1];

						if(get_pcvar_num(ps_lan_mode))
							get_user_authid(id, steamid, MAX_LENGTH);

						else
							formatex(steamid, MAX_LENGTH, "%s", g_info[id]);

						console_print(id, "[PS] Gave the %s %d points", string, points);
						log_amx("%L", LANG_SERVER, "ADMIN_TEAM_LOG_A", info[0], steamid, string, points);

						g_shown = true;
					}
				}
			}
		}
	}

	else
	{
		new target = cmd_target(id, arg1, CMDTARGET_ALLOW_SELF);
		static name[2][MAX_LENGTH + 1];

		get_user_name(id, name[0], MAX_LENGTH);
		get_user_name(target, name[1], MAX_LENGTH);

		if(!target)
		{
			console_print(id, "%L", id, "ADMIN_PLAYER_NONE", arg1);
			return 1;
		}

		else if(g_banned[target])
		{
			console_print(id, "%L", id, "ADMIN_PLAYER_BANNED", name[1]);
			return 1;
		}

		else
		{
			update_points(target, points, _, 1);

			static steamid[2][MAX_LENGTH + 1];

			if(get_pcvar_num(ps_lan_mode))
			{
				get_user_authid(id, steamid[0], MAX_LENGTH);
				get_user_authid(target, steamid[1], MAX_LENGTH);
			}

			else
			{
				formatex(steamid[0], MAX_LENGTH, "%s", g_info[id]);
				formatex(steamid[1], MAX_LENGTH, "%s", g_info[target]);
			}

			switch(get_pcvar_num(ps_show))
			{
				case 1: point_print(0, "%L", LANG_PLAYER, "ADMIN_NOTE_POINT_1A", name[1], points);
				case 2: point_print(0, "%L", LANG_PLAYER, "ADMIN_NOTE_POINT_2A", name[0], name[1], points);
			}

			console_print(id, "%L", id, "ADMIN_POINT_1A", name[1], points);
			log_amx("%L", LANG_SERVER, "ADMIN_POINT_LOG_A", name[0], steamid[0], name[1], steamid[1], points);

			log_ps("%s got %d points", name[1], points);
		}
	}

	return 1;
}

public ps_subtract(id, level, cid)
{
	if(!cmd_access(id, level, cid, 3))
		return 1;

	if(!is_ps_on())
	{
		client_print(id, print_console, "%L", id, "POINT_DISABLED");
		return 1;
	}

	static arg1[24];
	static arg2[12];

	read_argv(1, arg1, 23);
	read_argv(2, arg2, 11);

	new points = str_to_num(arg2);

	if(arg1[0] == '@')
	{
		new bool:g_shown;
		new team = 0;

		switch(arg1[1])
		{
			case 'T' : team = 1;
			case 'C' : team = 2;
		}

		static info[2][MAX_LENGTH + 1];

		get_user_name(id, info[0], MAX_LENGTH);

		if(get_pcvar_num(ps_lan_mode))
			get_user_authid(id, info[1], MAX_LENGTH);

		else
			info[1] = g_info[id];

		for(new i = 1; i <= g_maxplayers; i++)
		{
			if(!team && !is_false_user(i))
			{
				update_points(i, points, 0, 1);

				if(!g_shown)
				{
					switch(get_pcvar_num(ps_show))
					{
						case 1: point_print(0, "%L", LANG_PLAYER, "ADMIN_NOTE_EVERYONE_1S", points);
						case 2: point_print(0, "%L", LANG_PLAYER, "ADMIN_NOTE_EVERYONE_2S", info[0], points);
					}

					console_print(id, "%L", id, "ADMIN_EVERYONE_1S", points);
					log_amx("%L", LANG_SERVER, "ADMIN_EVERYONE_2S", info[0], info[1], points);

					g_shown = true;
				}
			}

			else
			{
				if(get_user_team(i) == team && !is_false_user(i))
				{
					update_points(i, points, 0, 1);
					static string[24];

					if(team == 2)
						formatex(string, 23, "Counter-Terrorists");

					else
						formatex(string, 23, "Terrorists");

					switch(get_pcvar_num(ps_show))
					{
						case 1: point_print(0, "%L", LANG_PLAYER, "ADMIN_NOTE_TEAM_1S", string, points);
						case 2: point_print(0, "%L", LANG_PLAYER, "ADMIN_NOTE_TEAM_2S", info[0], string, points);
					}

					console_print(id, "%L", id, "ADMIN_CONS_TEAM_S", string, points);
					log_amx("^"%s^" SteamID: <%i> Subtracted the %s points with %d", info[0], info[1], string, points);

					log_ps("%L", LANG_SERVER, "ADMIN_LOGS_TEAM_S", string, points);
				}
			}
		}
	}

	else
	{
		new target = cmd_target(id, arg1, CMDTARGET_ALLOW_SELF);
		static name[2][MAX_LENGTH + 1];

		get_user_name(id, name[0], MAX_LENGTH);
		get_user_name(target, name[1], MAX_LENGTH);

		if(!target)
		{
			console_print(id, "%L", id, "ADMIN_PLAYER_NONE", arg1);
			return 1;
		}

		else if(g_banned[target])
		{
			console_print(id, "%L", id, "ADMIN_PLAYER_BANNED", name[1]);
			return 1;
		}

		else if(get_user_flags(target) & ADMIN_IMMUNITY)
		{
			point_print(id, "%L", id, "POINT_IMMUNITY", name[1]);
			return 1;
		}

		else
		{
			update_points(target, points, 0, 1);
			static steamid[2][MAX_LENGTH + 1];

			if(get_pcvar_num(ps_lan_mode))
			{
				get_user_authid(id, steamid[0], MAX_LENGTH);
				get_user_authid(target, steamid[1], MAX_LENGTH);
			}

			else
			{
				formatex(steamid[0], MAX_LENGTH, "%s", g_info[id]);
				formatex(steamid[1], MAX_LENGTH, "%s", g_info[target]);
			}

			switch(get_pcvar_num(ps_show))
			{
				case 1: point_print(0, "%L", LANG_PLAYER, "ADMIN_NOTE_POINT_1S", name[1], points);
				case 2: point_print(0, "%L", LANG_PLAYER, "ADMIN_NOTE_POINT_2S", name[0], name[1], points);
			}

			console_print(id, "%L", id, "ADMIN_POINT_1S", name[1], points);
			log_amx("%L", LANG_SERVER, "ADMIN_POINT_LOG_A", name[0], steamid[0], name[1], steamid[1], points);

			log_ps("%s's points was subtracted by %d", name[1], points);
		}
	}

	return 1;
}

public ps_ban(id, level, cid)
{
	if(!cmd_access(id, level, cid, 2))
		return 1;

	if(!is_ps_on())
	{
		client_print(id, print_console, "%L", id, "POINT_DISABLED");
		return 1;
	}

	static arg1[24];
	read_argv(1, arg1, 23);

	new target = cmd_target(id, arg1, CMDTARGET_ALLOW_SELF);
	static name[2][MAX_LENGTH + 1];

	get_user_name(id, name[0], MAX_LENGTH);
	get_user_name(target, name[1], MAX_LENGTH);

	if(!target)
	{
		console_print(id, "%L", id, "ADMIN_PLAYER_NONE", arg1);
		return 1;
	}

	else if(g_banned[target])
		console_print(id, "%L", id, "ADMIN_IS_BANNED", name[1]);

	else if(get_user_flags(target) & ADMIN_IMMUNITY)
			point_print(id, "%L", id, "POINT_IMMUNITY", name[1]);

	else
	{
		g_banned[target] = true;
		static steamid[2][MAX_LENGTH + 1];

		if(get_pcvar_num(ps_lan_mode))
		{
			get_user_authid(id, steamid[0], MAX_LENGTH);
			get_user_authid(target, steamid[1], MAX_LENGTH);
		}

		else
		{
			formatex(steamid[0], MAX_LENGTH, "%s", g_info[id]);
			formatex(steamid[1], MAX_LENGTH, "%s", g_info[target]);
		}

		switch(get_pcvar_num(ps_show))
		{
			case 1: point_print(0, "%L", LANG_PLAYER, "ADMIN_NOTE_BANNED_1A", name[1]);
			case 2: point_print(0, "%L", LANG_PLAYER, "ADMIN_NOTE_BANNED_2A", name[0], name[1]);
		}

		console_print(id, "%L", id, "ADMIN_BANNED_1A", name[1]);
		log_amx("%L", LANG_SERVER, "ADMIN_BANNED_LOG_A", name[0], steamid[0], name[1], steamid[1]);
	}

	return 1;
}

public ps_unban(id, level, cid)
{
	if(!cmd_access(id, level, cid, 2))
		return 1;

	if(!is_ps_on())
	{
		client_print(id, print_console, "%L", id, "POINT_DISABLED");
		return 1;
	}

	static arg1[24];
	read_argv(1, arg1, 23);

	new target = cmd_target(id, arg1, CMDTARGET_ALLOW_SELF);
	static name[2][MAX_LENGTH + 1];

	get_user_name(id, name[0], MAX_LENGTH);
	get_user_name(target, name[1], MAX_LENGTH);

	if(!target)
	{
		console_print(id, "%L", id, "ADMIN_PLAYER_NONE", arg1);
		return 1;
	}

	else if(!g_banned[target])
		console_print(id, "%L", id, "ADMIN_IS_UNBANNED", name[1]);

	else
	{
		g_banned[target] = false;
		static steamid[2][MAX_LENGTH + 1];

		if(get_pcvar_num(ps_lan_mode))
		{
			get_user_authid(id, steamid[0], MAX_LENGTH);
			get_user_authid(target, steamid[1], MAX_LENGTH);
		}

		else
		{
			formatex(steamid[0], MAX_LENGTH, "%s", g_info[id]);
			formatex(steamid[1], MAX_LENGTH, "%s", g_info[target]);
		}

		switch(get_pcvar_num(ps_show))
		{
			case 1: point_print(0, "%L", LANG_PLAYER, "ADMIN_NOTE_BANNED_1A", name[1]);
			case 2: point_print(0, "%L", LANG_PLAYER, "ADMIN_NOTE_BANNED_2A", name[0], name[1]);
		}

		console_print(id, "%L", id, "ADMIN_UNBANNED_1A", name[1]);
		log_amx("%L", LANG_SERVER, "ADMIN_UNBANNED_LOG_A", name[0], steamid[0], name[1], steamid[1]);
	}

	return 1;
}

public ps_remove_models(id, level, cid)
{
	if(!cmd_access(id, level, cid, 3))
		return 1;

	if(!is_ps_on())
	{
		client_print(id, print_console, "%L", id, "POINT_DISABLED");
		return 1;
	}

	new arg[2][24];

	read_argv(1, arg[0], 23);
	read_argv(2, arg[1], 23);

	new target = cmd_target(id, arg[0], CMDTARGET_ALLOW_SELF);
	static name[2][MAX_LENGTH + 1];

	get_user_name(id, name[0], MAX_LENGTH);
	get_user_name(target, name[1], MAX_LENGTH);

	if(!target)
	{
		console_print(id, "%L", id, "ADMIN_PLAYER_NONE", arg[0]);
		return 1;
	}

	if(g_banned[target])
	{
		console_print(id, "%L", id, "ADMIN_PLAYER_BANNED", name[1]);
		return 1;
	}

	else
	{
		static steamid[2][MAX_LENGTH + 1]; new team;

		if(containi(arg[1], "CT") != -1 || containi(arg[1], "Counter") != -1)
			team = 2;

		else if(equali(arg[1], "T") || equali(arg[1], "Terrorist"))
			team = 1;

		else
		{
			console_print(id, "%L", id, "ADMIN_VALID_TEAM", "CT", "T");
			return 1;
		}

		if(get_pcvar_num(ps_lan_mode))
		{
			get_user_authid(id, steamid[0], MAX_LENGTH);
			get_user_authid(target, steamid[1], MAX_LENGTH);
		}

		else
		{
			formatex(steamid[0], MAX_LENGTH, "%s", g_info[id]);
			formatex(steamid[1], MAX_LENGTH, "%s", g_info[target]);
		}

		if(team == 1)
		{
			if(!g_status[target][1])
			{
				console_print(id, "%L", id, "ADMIN_MODEL_NONE", name[1], "Terrorist");
				return 1;
			}

			change_status(target, 2, 0, 0);
			g_cpm_t[target] = false;

			switch(get_pcvar_num(ps_show))
			{
				case 1: point_print(0, "%L", LANG_PLAYER, "ADMIN_NOTE_MODEL_1A", name[1]);
				case 2: point_print(0, "%L", LANG_PLAYER, "ADMIN_NOTE_MODEL_2A", name[0], name[1]);
			}

			console_print(id, "%L", id, "ADMIN_MODEL_1A", name[1]);
			log_amx("%L", LANG_SERVER, "ADMIN_MODEL_LOG_A", name[0], steamid[0], name[1], steamid[1]);
		}

		else if(team == 2)
		{
			if(!g_status[target][5])
			{
				console_print(id, "%L", id, "ADMIN_MODEL_NONE", name[1], "Counter-Terrorist");
				return 1;
			}

			change_status(target, 6, 0, 0);
			g_cpm_ct[target] = false;

			switch(get_pcvar_num(ps_show))
			{
				case 1: point_print(0, "%L", LANG_PLAYER, "ADMIN_NOTE_MODEL_1A", name[1]);
				case 2: point_print(0, "%L", LANG_PLAYER, "ADMIN_NOTE_MODEL_2A", name[0], name[1]);
			}

			console_print(id, "%L", id, "ADMIN_MODEL_1A", name[1]);
			log_amx("%L", LANG_SERVER, "ADMIN_MODEL_LOG_A", name[0], steamid[0], name[1], steamid[1]);
		}
	}

	return 1;
}

public ps_give_model(id, level, cid)
{
	if(!cmd_access(id, level, cid, 3))
		return 1;

	if(!is_ps_on())
	{
		client_print(id, print_console, "%L", id, "POINT_DISABLED");
		return 1;
	}

	new arg[2][24];

	read_argv(1, arg[0], 23);
	read_argv(2, arg[1], 23);

	g_admin_target[id] = cmd_target(id, arg[0], CMDTARGET_ALLOW_SELF);

	if(!g_admin_target[id])
	{
		console_print(id, "%L", id, "ADMIN_PLAYER_NONE", arg[0]);
		return 1;
	}

	if(g_banned[g_admin_target[id]])
	{
		new name[MAX_LENGTH + 1];
		get_user_name(g_admin_target[id], name, MAX_LENGTH);

		console_print(id, "%L", id, "ADMIN_PLAYER_BANNED", name);
		return 1;
	}

	else
	{
		if(containi(arg[1], "CT") != -1 || containi(arg[1], "Counter") != -1)
			g_admin_team[id] = 2;

		else if(equali(arg[1], "T") || equali(arg[1], "Terrorist"))
			g_admin_team[id] = 1;

		else
		{
			console_print(id, "%L", id, "ADMIN_VALID_TEAM", "CT", "T");
			return 1;
		}

		if(g_admin_team[id] == 1)
		{
			if(TotalModels_T)
			{
				new menu_id_model_t = menu_create("[M]odel Menu", "cpm_admin_models");

				for(new i = 0; i < TotalModels_T; i++)
					if(file_exists(PLMDL_T[i]))
						menu_additem(menu_id_model_t, PLNAME_T[i], PLNAME_T[i], -1);

				menu_setprop(menu_id_model_t, MPROP_EXIT, MEXIT_ALL);
				menu_display(id, menu_id_model_t, 0);

				console_print(id, "%L", id, "ADMIN_MENU_OPEN", "Terrorist");
			}

			else
				point_print(id, "%L", id, "POINT_NO_MODELS");
		}

		else if(g_admin_team[id] == 2)
		{
			if(TotalModels_CT)
			{
				new menu_id_model_ct = menu_create("[M]odel Menu", "cpm_admin_models");

				for(new i = 0; i < TotalModels_CT; i++)
					if(file_exists(PLMDL_CT[i]))
						menu_additem(menu_id_model_ct, PLNAME_CT[i], PLNAME_CT[i], -1);

				menu_setprop(menu_id_model_ct, MPROP_EXIT, MEXIT_ALL);
				menu_display(id, menu_id_model_ct, 0);

				console_print(id, "%L", id, "ADMIN_MENU_OPEN", "Counter-Terrorist");
			}

			else
				point_print(id, "%L", id, "POINT_NO_MODELS");
		}
	}

	return 1;
}

public ps_clean_db(id, level, cid)
{
	if(!cmd_access(id, level, cid, 3))
		return 1;

	if(!is_ps_on())
	{
		client_print(id, print_console, "%L", id, "POINT_DISABLED");
		return 1;
	}

	new arg[2][18], value;

	read_argv(1, arg[0], 17);
	read_argv(2, arg[1], 17);

	value = str_to_num(arg[1]);

	if(!arg[0][0])
	{
		console_print(id, "%L", id, "ADMIN_CL_DB_USAGE");
		return 1;
	}

	else if(equali(arg[0], "yes"))
	{
		console_print(id, "%L", id, "ADMIN_REMOVING_ENTRIES");

		#if defined SAVE_SQL
		new sql[512], data[3];

		data[0] = DELETE_ENTRIES;
		data[1] = id;

		formatex(sql, 511, "SELECT steamid FROM `%s` WHERE `points` <= %d", g_table, value);
		SQL_ThreadQuery(g_SqlTuple, "sql_public_handle", sql, data, 2);
		#else

		new key[38], data[64], points[8], ps, deleted;
		new fsize = fvault_size(g_points_vault);

		for(new i = 0; i <= fsize; i++)
		{
			fvault_get_keyname(g_points_vault, i, key, charsmax(key));
			fvault_get_data(g_points_vault, key, data, charsmax(data));

			replace_all(data, 63, "#", " ");
			parse(data, points, 7);

			ps = str_to_num(points);

			if(ps <= value) { deleted++; set_task(0.2, "delete_entries", _, key, 37); }
		}

		console_print(id, "%L", id, "ADMIN_REMOVED_ENTRIES", deleted);
		#endif
	}

	return 1;
}

public ps_reset_db(id, level, cid)
{
	if(!cmd_access(id, level, cid, 2))
		return 1;

	if(!is_ps_on())
	{
		client_print(id, print_console, "%L", id, "POINT_DISABLED");
		return 1;
	}

	new arg[24];
	read_argv(1, arg, 23);

	if(!arg[0])
	{
		console_print(id, "%L", id, "ADMIN_RS_DB_USAGE");
		return 1;
	}

	else if(equali(arg, "yes"))
	{
		#if defined SAVE_SQL
		new sql[512], data[2];

		data[0] = DELETE_RESTART;
		data[1] = id;

		formatex(sql, 511, "DELETE FROM `%s`", g_table);
		SQL_ThreadQuery(g_SqlTuple, "sql_public_handle", sql, data, 2);

		#else
		fvault_clear(g_points_vault);
		fvault_clear(g_status_vault);

		server_cmd("restart");
		#endif
	}

	return 1;
}

public ps_plugin(id, level, cid)
{
	if(!cmd_access(id, level, cid, 1))
		return 1;

	new temp[2];
	read_argv(1, temp, 1);

	if(!temp[0])
	{
		console_print(id, "%L", id, "ADMIN_TOGGLE_USAGE");
		return 1;
	}

	new num = str_to_num(temp[0]);

	if(num == g_iPlugin)
	{
		return 1;
	}

	g_iPlugin = num;

	if(!num)
	{
		console_print(id, "%L", id, "ADMIN_PLUGIN_OFF", gPLUGIN);

		unregister_message(g_iMsgHLTV, g_iHltvID);
		unregister_message(g_iMsgDeath, g_iDeathID);

		unregister_message(g_iMsgAudio, g_iMessage);
		unregister_forward(FM_GetGameDescription, g_iDescription);

		unregister_forward(FM_SetClientKeyValue, g_iKeyValue);
		unregister_forward(FM_Think, g_iThink);

		DisableHamForward(g_iHamDmg);
		DisableHamForward(g_iHamSpawn);

		DisableHamForward(g_iHamPost);
		DisableHamForward(g_iHamPre);
	}

	else
	{
		console_print(id, "%L", id, "ADMIN_PLUGIN_ON", gPLUGIN);

		register_message(g_iMsgHLTV, "round_start");
		register_message(g_iMsgDeath, "fwd_Client_Killed");

		register_message(g_iMsgAudio, "round_won");
		register_forward(FM_GetGameDescription,	"fwd_Game_Desc");

		register_forward(FM_SetClientKeyValue,	"fwd_Client_KeyValue");
		register_forward(FM_Think,		"fwd_Entity_Think");

		EnableHamForward(g_iHamDmg);
		EnableHamForward(g_iHamSpawn);

		EnableHamForward(g_iHamPost);
		EnableHamForward(g_iHamPre);

		for(new i = 1; i <= g_maxplayers; i++)
		{
			if(!g_points[id])
			{
				get_data(id);
			}
		}
	}

	return 1;
}