/*======================================
	    [Data PS File]
======================================*/

update_points(id, amount, status = 1, sound = 0)
{
	if(!g_banned[id])
	{
		ExecuteForward(g_fwd_points_pre, g_fwd_dummy, id, amount, status);

		if(status)
		{
			g_mPoints[id] += amount;
			g_points[id] += amount;

			if(sound && get_pcvar_num(ps_sound)) client_cmd(id, "spk %s", g_sound_add);
		}

		else
		{
			g_mPoints[id] -= amount;
			g_points[id] -= amount;

			if(sound && get_pcvar_num(ps_sound)) client_cmd(id, "spk %s", g_sound_subtract);
		}

		if(g_points[id] < 0) g_points[id] = 0;
		ExecuteForward(g_fwd_points_post, g_fwd_dummy, id, amount, status);

		#if defined SAVE_SQL
		if(get_pcvar_num(ps_sql_fast))
			set_data(id);
		#endif
	}
}

set_data(id)
{
	// Check Information
	if(!g_info[id][0] || is_false_user(id)) return;

	if(g_points[id]) if(g_points[id] > 9999999) g_points[id] = 9999999;

	#if defined SAVE_SQL
	static sql[512], data[2];

	data[0] = LOAD_NONE;
	data[1] = id;

	if(!g_exists[id]) return;

	if(g_exists[id] == -1)
	{
		formatex(sql, 511, "INSERT INTO `%s` (`steamid`) VALUES('%s')", g_table, g_info[id]);
		SQL_ThreadQuery(g_SqlTuple, "sql_public_handle", sql, data, 2);

		g_exists[id] = 1;
	}

	static name[MAX_LENGTH + 1];
	get_user_name(id, name, MAX_LENGTH);

	sqlx_check(name, sizeof(name) - 1);
	html_check(name, sizeof(name) - 1);

	formatex(sql, 511, "UPDATE `%s` SET `name`='%s', `points`=%d, `status`='%d#%d#%d#%d#%d#%d#%d#%d' WHERE (steamid = '%s')", g_table, name, g_points[id], g_status[id][0], g_status[id][1], g_status[id][2], g_status[id][3], g_status[id][4], g_status[id][5], g_status[id][6], g_banned[id], g_info[id]);
	SQL_ThreadQuery(g_SqlTuple, "sql_public_handle", sql, data, 2);

	#else
	save_points(id, g_points[id]);

	new key[38], data[64];
	formatex(key, 37, "%s-PS", g_info[id]);

	// Save Status
	formatex(data, 63, "%d#%d#%d#%d#%d#%d#%d#%d", g_status[id][0], g_status[id][1], g_status[id][2], g_status[id][3], g_status[id][4], g_status[id][5], g_status[id][6], g_banned[id]);
	fvault_set_data(g_status_vault, key, data);
	#endif
}

get_data(id)
{
	// Check Information
	if(!g_info[id][0] || is_false_user(id)) return;

	#if defined SAVE_SQL
	static sql[512], data[2];

	data[0] = LOAD_POINTS;
	data[1] = id;

	formatex(sql, 511, "SELECT `points` FROM `%s` WHERE `steamid` = '%s'", g_table, g_info[id]);
	SQL_ThreadQuery(g_SqlTuple, "sql_public_handle", sql, data, 2);

	data[0] = LOAD_STATUS;

	formatex(sql, 511, "SELECT `status` FROM `%s` WHERE `steamid` = '%s'", g_table, g_info[id]);
	SQL_ThreadQuery(g_SqlTuple, "sql_public_handle", sql, data, 2);

	#else

	static key[38], data[64], ps[8];
	formatex(key, 37, "%s-PS", g_info[id]);

	// Load Points
	if(fvault_get_data(g_points_vault, key, data, 63))
	{
		replace_all(data, 63, "#", " ");
		parse(data, ps, 7);

		g_points[id] = str_to_num(ps);
	}

	else { g_points[id] = false; }

	data = "";

	// Load Status
	fvault_get_data(g_status_vault, key, data, 63);
	replace_all(data, 63, "#", " ");

	new status[7][8], banned[2];
	parse(data, status[0], 7, status[1], 7, status[2], 7, status[3], 7, status[4], 7, status[5], 7, status[6], 7, banned, 1);

	g_banned[id] = str_to_num(banned);

	for(new i = 0; i <= 6; i++)
		g_status[id][i] = str_to_num(status[i]);
	#endif
}

change_status(index, status, value, sound = 1)
{
	/******************
	*
	* [Status Options]
	*
	* 1 = VIP Votekick | VIP
	*
	* 2 = Custom PM | CPM
	*
	* 3 = Mute Rights | MRS
	*
	* 4 = VIP MRs | VRS
	*
	* 5 = Muted | MTD
	*
	* 6 = Custom PM CT | CPT
	*
	* 7 = Reserved Slot | RST
	*
	******************/

	if(is_ps_on() && !g_banned[index] && gb_user_connected[index] && 1 <= status <= 7)
	{
		ExecuteForward(g_fwd_status_pre, g_fwd_dummy, index, status, value);
		g_status[index][status - 1] = value;
		ExecuteForward(g_fwd_status_post, g_fwd_dummy, index, status, value);

		if(sound && get_pcvar_num(ps_sound))
			client_cmd(index, "spk %s", g_sound_status);
	}

	return 0;
}

#if !defined SAVE_SQL
save_points(id, g_ps)
{
	if(g_ps)
	{
		static name[MAX_LENGTH + 1], wData[64], wKey[38];
		formatex(wKey, 37, "%s-PS", g_info[id]);

		if(!get_pcvar_num(ps_lan_mode))
		{
			get_user_name(id, name, MAX_LENGTH);
			replace_all(name, MAX_LENGTH, " ", "-");

			formatex(wData, 63, "%d#%s", g_ps, name);
		}

		else
			formatex(wData, 63, "%d", g_ps, name);

		new fsize = fvault_size(g_points_vault);
		if(!fsize) fvault_set_data(g_points_vault, wKey, wData);

		else
		{
			static const temp_vault[] = "temp_ps_vault";
			static dir[2][64], ps[8];

			new points, bool:g_update;
			static key[38], data[64];

			for(new i = 0; i < fsize; i++)
			{
				fvault_get_keyname(g_points_vault, i, key, 37);
				fvault_get_data(g_points_vault, key, data, 63);

				replace_all(data, 63, "#", " ");
				new cont = contain(key, g_info[id]);

				if(!g_update && parse(data, ps, 7))
				{
					points = str_to_num(ps);

					if(points > g_ps) { if(cont != -1) { return; }}

					else if(points == g_ps) { if(cont != -1) { return; }}

					else if(points < g_ps)
					{
						fvault_set_data(temp_vault, wKey, wData);
						g_update = true;
					}
				}

				if(cont == -1) fvault_set_data(temp_vault, key, data);
			}

			if(!g_update) { fvault_set_data(temp_vault, wKey, wData); }

			formatex(dir[0], 63, "%s/%s.txt", _vault_dir, g_points_vault);
			formatex(dir[1], 63, "%s/%s.txt", _vault_dir, temp_vault);

			delete_file(dir[0]);
			while(!rename_file(dir[1], dir[0], 1)) {}

			if(file_exists(dir[1])) delete_file(dir[1]);
		}
	}
}

public delete_entries(key[])
{
	fvault_remove_key(g_points_vault, key);
	fvault_remove_key(g_status_vault, key);
}

#else

public sql_public_handle(failstate, Handle:Query, error[], errcode, data[], datasize, Float:queuetime)
{
	new mode = data[0];
	new id	 = data[1];

	switch(failstate)
	{
		case TQUERY_CONNECT_FAILED:	return set_fail_state("[PS] Could not connect to the SQL Database");
		case TQUERY_QUERY_FAILED:	return set_fail_state("[PS] The table Query Failed");
	}

	if(errcode) return log_amx("[PS][%d] Error on Query: %s", mode, error);

	switch(mode)
	{
		case LOAD_POINTS:
		{
			if(SQL_NumResults(Query))
			{
				g_points[id] = SQL_ReadResult(Query, 0);
				g_exists[id] = 1;
			}

			else
			{
				g_points[id]	= false;
				g_exists[id]	= -1;
			}
		}

		case LOAD_STATUS:
		{
			if(SQL_NumResults(Query))
			{
				new info[MAX_LENGTH + 1];
				SQL_ReadResult(Query, 0, info, MAX_LENGTH);

				new status[8][8];
				replace_all(info, MAX_LENGTH, "#", " ");

				parse(info, status[0], 7, status[1], 7, status[2], 7, status[3], 7, status[4], 7, status[5], 7, status[6], 7, status[7], 7);

				g_banned[id] = str_to_num(status[7]);

				for(new i = 0; i <= 6; i++)
					g_status[id][i] = str_to_num(status[i]);
			}

			else
			{
				for(new i = 0; i <= 6; i++)
					g_status[id][i] = false;
			}
		}

		case DELETE_RESTART:
		{
			log_ps("Database Deletion took: %f seconds", queuetime);
			server_cmd("restart");
		}

		case DELETE_ENTRIES:
		{
			new times, sSteam[MAX_LENGTH + 1], sql[1024];

			formatex(sql, 1023, "DELETE FROM `%s` WHERE", g_table);

			while(SQL_MoreResults(Query))
			{
				SQL_ReadResult(Query, 0, sSteam, MAX_LENGTH);

				if(!times) format(sql, 1023, "%s `steamid`='%s'", sql, sSteam);
				else format(sql, 1023, "%s OR `steamid`='%s'", sql, sSteam);

				times++;
				SQL_NextRow(Query);
			}

			console_print(id, "%L", id, "ADMIN_REMOVED_ENTRIES", times);

			if(times)
			{
				data[0] = LOAD_NONE;
				data[1] = false;

				SQL_ThreadQuery(g_SqlTuple, "sql_public_handle", sql, data, 2);
			}
		}

		case LOAD_ENTRIES:
		{
			g_total[id] = SQL_ReadResult(Query, 0);
		}

		case LOAD_RANKING:
		{
			new sSteam[MAX_LENGTH + 1], rank;

			while(SQL_MoreResults(Query))
			{
				rank++;

				SQL_ReadResult(Query, 0, sSteam, MAX_LENGTH);
				if(equal(sSteam, g_info[id])) break;

				SQL_NextRow(Query);
			}

			point_print(id, "%L", id, "POINT_RANK", rank, g_total[id], g_points[id]);
		}
	}

	return 0;
}

public sql_top_handle(failstate, Handle:Query, error[], errcode, pBuffer[], len, Float:queuetime)
{
	switch(failstate)
	{
		case TQUERY_CONNECT_FAILED:	return set_fail_state("[PS-15] Could not connect to the SQL Database");
		case TQUERY_QUERY_FAILED:	return set_fail_state("[PS-15] The table Query Failed");
	}

	if(errcode) return log_amx("[PS-15] Error on Query: %s", error);

	static sName[MAX_LENGTH + 1], num[8];
	new ps, times, points[8], id;

	replace(pBuffer, len, pBuffer[len], "");

	while((SQL_MoreResults(Query)) && (MOTD_LENGTH - strlen(pBuffer) > 0))
	{
		times++;

		ps = SQL_ReadResult(Query, 0);
		SQL_ReadResult(Query, 1, sName, MAX_LENGTH);

		num_to_str(ps, points, 7);
		num_to_str(times, num, 7);

		add(pBuffer, len, "<tr><td>");
		add(pBuffer, len, num);		// Place
		add(pBuffer, len, "</td><td>");
		add(pBuffer, len, sName);	// Name
		add(pBuffer, len, "</td><td>");
		add(pBuffer, len, points);	// Points

		if(times >= TOP_NUM) break;
		else SQL_NextRow(Query);
	}

	for(new i = 1; i <= g_maxplayers; i++)
	{
		if(g_ps15[i])
		{
			id = i;
		}
	}

	static title[MAX_LENGTH + 1];
	formatex(title, MAX_LENGTH, "%L", id, "POINT_PLAYER");

	add(pBuffer, MOTD_LENGTH, "</table></body></html>");
	show_motd(id, pBuffer, title);

	g_ps15[id] = false;
	return 0;
}
#endif

get_model_num(const model[], team)
{
	if(is_ps_on())
	{
		static dir[256];

		switch(team)
		{
			case 1: formatex(dir, 255, "%s", filedir3);
			case 2: formatex(dir, 255, "%s", filedir6);
		}

		new readdata[128], temp[84];
		new dummy[2][MAX_LENGTH + 1], name[MAX_LENGTH + 1];

		new fp = fopen(dir, "r");

		if(fp)
		{
			while(!feof(fp))
			{
				fgets(fp, readdata, 127);

				if(containi(readdata, ";") != -1) continue;

				parse(readdata, temp, 83, dummy[0], MAX_LENGTH, dummy[1], MAX_LENGTH);

				replace(temp, 83, "models", "");
				replace(temp, 83, "player", "");

				if(containi(temp, "/") != -1)
					replace_all(temp, 83, "/", " ");

				if(containi(temp, "\") != -1)
					replace_all(temp, 83, "\", " ");

				parse(temp, name, MAX_LENGTH); trim(name);

				if(equali(name, model))
				{
					new var = str_to_num(dummy[1]); fclose(fp);
					return var;
				}
			}
		}

		fclose(fp);
	}

	return 0;
}

get_user_model(num, string[], len, team)
{
	if(is_ps_on())
	{
		static dir[256];

		switch(team)
		{
			case 1: formatex(dir, 255, "%s", filedir3);
			case 2: formatex(dir, 255, "%s", filedir6);
		}

		new readdata[128], temp[84], var;
		new dummy[2][MAX_LENGTH + 1];

		new fp = fopen(dir, "r");

		if(fp)
		{
			while(!feof(fp))
			{
				fgets(fp, readdata, 127);
				if(containi(readdata, ";") != -1) continue;

				parse(readdata, temp, 83, dummy[0], MAX_LENGTH, dummy[1], MAX_LENGTH);
				var = str_to_num(dummy[1]);

				if(var == num)
				{
					replace(temp, 83, "models", "");
					replace(temp, 83, "player", "");

					if(containi(temp, "/") != -1)
						replace_all(temp, 83, "/", " ");

					if(containi(temp, "\") != -1)
						replace_all(temp, 83, "\", " ");

					parse(temp, string, len); break;
				}
			}
		}

		fclose(fp);
	}
}

get_model_file(const model_name[], file[], len, team)
{
	if(is_ps_on())
	{
		static dir[256];

		switch(team)
		{
			case 1: formatex(dir, 255, "%s", filedir3);
			case 2: formatex(dir, 255, "%s", filedir6);
		}

		new readdata[128], temp[84];
		new name[MAX_LENGTH + 1];

		new fp = fopen(dir, "r");

		if(fp)
		{
			while(!feof(fp))
			{
				fgets(fp, readdata, 127);
				if(containi(readdata, ";") != -1) continue;

				parse(readdata, temp, 83, name, MAX_LENGTH);

				if(equal(model_name, name))
				{
					replace(temp, 83, "models", "");
					replace(temp, 83, "player", "");

					if(containi(temp, "/") != -1)
						replace_all(temp, 83, "/", " ");

					if(containi(temp, "\") != -1)
						replace_all(temp, 83, "\", " ");

					parse(temp, file, len); trim(file); break;
				}
			}
		}

		fclose(fp);
	}
}

load_models_ct()
{
	if(file_exists(filedir6))
	{
		PLMDL_CT[0]	=	"";
		PLNAME_CT[0]	=	"None";

		new filedata[256], writedata[256], line = -1;
		new filep = fopen(filedir6, "rt");

		while(!feof(filep))
		{
			fgets(filep, filedata, 255); line++;
			if(containi(filedata, ";") != -1) continue;

			if(containi(filedata, "models/player/") != -1 || containi(filedata, "models\player\") != -1)
			{
				parse(filedata, PLMDL_CT[TotalModels_CT], 83, PLNAME_CT[TotalModels_CT], 83);

				if(file_exists(PLMDL_CT[TotalModels_CT]))
				{
					formatex(writedata, 255, "^"%s^" ^"%s^" %d", PLMDL_CT[TotalModels_CT], PLNAME_CT[TotalModels_CT], (TotalModels_CT + 1));
					write_file(filedir6, writedata, line);

					TotalModels_CT++;
				}
			}
		}

		fclose(filep);
	}

	log_ps("Loaded %d Counter-Terrorist Models", TotalModels_CT);
}

load_models_t()
{
	if(file_exists(filedir3))
	{
		PLMDL_T[0]	=	"";
		PLNAME_T[0]	=	"None";

		new filedata[256], writedata[256], line = -1;
		new filep = fopen(filedir3, "rt");

		while(!feof(filep))
		{
			fgets(filep, filedata, 255); line++;
			if(containi(filedata, ";") != -1) continue;

			if(containi(filedata, "models/player/") != -1 || containi(filedata, "models\player\") != -1)
			{
				parse(filedata, PLMDL_T[TotalModels_T], 83, PLNAME_T[TotalModels_T], 83);

				if(file_exists(PLMDL_T[TotalModels_T]))
				{
					formatex(writedata, 255, "^"%s^" ^"%s^" %d", PLMDL_T[TotalModels_T], PLNAME_T[TotalModels_T], (TotalModels_T + 1));
					write_file(filedir3, writedata, line);

					TotalModels_T++;
				}
			}
		}

		fclose(filep);
	}

	log_ps("Loaded %d Terrorist Models", TotalModels_T);
}