/*======================================
	     [Handle PS File]
======================================*/

public show_points(id)
{
	if(gb_user_connected[id])
	{
		point_print(id, "%L", id, "POINT_DISPLAY", g_points[id]);
	}

	return get_pcvar_num(ps_hide) ? 1 : 0;
}

public show_top_players(id)
{
	if(gb_user_connected[id])
	{
		static pBuffer[MOTD_LENGTH + 1]; pBuffer = "";
		format_motd_top(id, pBuffer);
	}
}

public show_top_points(id)
{
	if(gb_user_connected[id])
	{
		static sBuffer[MOTD_LENGTH + 1]; sBuffer = "";
		format_motd_points(sBuffer);

		static title[34];
		formatex(title, 33, "%L", id, "POINT_TOP_PLR");

		show_motd(id, sBuffer, title);
	}
}

public show_gp_motd(id)
{
	if(gb_user_connected[id])
	{
		static filedir[128];

		if(!filedir[0])
		{
			get_configsdir(filedir, 127);
			format(filedir, 127, "%s/ps/ps_gp.txt", filedir);
		}

		show_motd(id, filedir, "Point - System GamePlay");
	}
}

public show_help_motd(id)
{
	if(gb_user_connected[id])
	{
		static string[34];
		formatex(string, 33, "%L", LANG_SERVER, "POINT_COMMANDS");

		show_motd(id, filedir4, string);
	}
}

public show_rank(id)
{
	if(gb_user_connected[id])
	{
		#if defined SAVE_SQL
		new sql[512], data[2];

		data[0] = LOAD_ENTRIES;
		data[1] = id;

		formatex(sql, 511, "SELECT COUNT(`points`) FROM `%s`", g_table);
		SQL_ThreadQuery(g_SqlTuple, "sql_public_handle", sql, data, 3);

		data[0] = LOAD_RANKING;

		formatex(sql, 511, "SELECT `steamid`, `points` FROM `%s` ORDER BY `points` DESC", g_table);
		SQL_ThreadQuery(g_SqlTuple, "sql_public_handle", sql, data, 3);

		#else

		new key[38];
		formatex(key, 37, "%s-PS", g_info[id]);

		point_print(id, "%L", id, "POINT_RANK", (fvault_get_keynum(g_points_vault, key) + 1), fvault_size(g_points_vault), g_points[id]);
		#endif
	}
}

public show_points_menu(id)
{
	if(gb_user_connected[id])
	{
		points_menu(id);
	}
}

db_handle(id)
{
	if(is_ps_on() && gb_user_connected[id])
	{
		if(g_DoubleUsed[id] || g_DoubleJump[id] || g_DoubleRend[id])
		{
			point_print(id, "%L", id, "POINT_ALREADY");
			return;
		}

		new status = get_pcvar_num(ps_dj_cost);

		if(g_points[id] < status)
		{
			point_print(id, "%L", id, "POINT_AFFORD");
			point_print(id, "%L", id, "POINT_CHECK", g_points[id], status);
		}

		else
		{
			update_points(id, status, 0, 0);

			point_print(id, "%L", id, "POINT_DB_JUMP");
			point_print(id, "%L", id, "POINT_CURRENT", g_points[id]);

			g_DoubleJump[id] = true;
		}
	}
}

dm_handle(id)
{
	if(is_ps_on() && gb_user_connected[id])
	{
		if(g_DamageUsed[id] || g_DamageMult[id] || g_DamageRend[id])
		{
			point_print(id, "%L", id, "POINT_ALREADY");
			return;
		}

		new status = get_pcvar_num(ps_dm_cost);

		if(g_points[id] < status)
		{
			point_print(id, "%L", id, "POINT_AFFORD");
			point_print(id, "%L", id, "POINT_CHECK", g_points[id], status);
		}

		else
		{
			update_points(id, status, 0, 0);

			point_print(id, "%L", id, "POINT_DM_PC");
			point_print(id, "%L", id, "POINT_CURRENT", g_points[id]);

			g_DamageMult[id] = true;
		}
	}
}

cm_handle(id)
{
	if(is_ps_on() && gb_user_connected[id])
	{
		if(do_chameleon[id] || g_Chameleon[id] || g_ChameRend[id])
		{
			point_print(id, "%L", id, "POINT_ALREADY");
			return;
		}

		new status = get_pcvar_num(ps_cm_cost);

		if(g_points[id] < status)
		{
			point_print(id, "%L", id, "POINT_AFFORD");
			point_print(id, "%L", id, "POINT_CHECK", g_points[id], status);
		}

		else
		{
			update_points(id, status, 0, 0);

			point_print(id, "%L", id, "POINT_CHAMELEON");
			point_print(id, "%L", id, "POINT_CURRENT", g_points[id]);

			fm_get_user_model(id, g_curModel[id], MAX_LENGTH);
			g_Chameleon[id] = true;
		}
	}
}

rs_handle(id)
{
	if(is_ps_on() && gb_user_connected[id])
	{
		if(get_user_flags(id) & ADMIN_RESERVATION)
		{
			point_print(id, "%L", id, "POINT_ALREADY");
			return;
		}

		new status = get_pcvar_num(ps_rs_cost);

		if(g_points[id] < status)
		{
			point_print(id, "%L", id, "POINT_AFFORD");
			point_print(id, "%L", id, "POINT_CHECK", g_points[id], status);
		}

		else
		{
			new status = get_pcvar_num(ps_rs_weeks);

			update_points(id, get_pcvar_num(ps_rs_cost), 0, 0);

			point_print(id, "%L", id, "POINT_RESERVED", status);
			point_print(id, "%L", id, "POINT_CURRENT", g_points[id]);

			change_status(id, 7, (get_systime_h() + ((status * 24) * 7)));
			set_user_flags(id, ADMIN_RESERVATION);

			ps_edit_admin(g_info[id], _, "b", "ce");
		}
	}
}

vip_handle(id)
{
	if(is_ps_on() && gb_user_connected[id])
	{
		new status = get_pcvar_num(ps_vip_cost);

		if(g_points[id] < status)
		{
			point_print(id, "%L", id, "POINT_AFFORD");
			point_print(id, "%L", id, "POINT_CHECK", g_points[id], status);
		}

		else
		{
			update_points(id, status, 0, 0);

			point_print(id, "%L", id, "POINT_VIP");
			point_print(id, "%L", id, "POINT_CURRENT", g_points[id]);

			change_status(id, 1, 7);
		}
	}
}

cpm_handle(id, const model[])
{
	if(is_ps_on() && gb_user_connected[id])
	{
		new status = get_pcvar_num(ps_cpm_cost);

		if(g_points[id] < status)
		{
			point_print(id, "%L", id, "POINT_AFFORD");
			point_print(id, "%L", id, "POINT_CHECK", g_points[id], status);
		}

		else
		{
			new team;

			switch(fm_get_user_team(id))
			{
				case FM_TEAM_CT: team = 2;
				case FM_TEAM_T:  team = 1;
			}

			static file[MAX_LENGTH + 1];
			get_model_file(model, file, MAX_LENGTH, team);

			fm_set_user_model(id, file);
			new num = get_model_num(file, team);

			switch(team)
			{
				case 1:
				{
					if(num != g_status[id][1])
					{
						change_status(id, 2, num);
						update_points(id, status, 0, 0);

						point_print(id, "%L", id, "POINT_MODELS", model);
						point_print(id, "%L", id, "POINT_CURRENT", g_points[id]);

						g_cpm_t[id] = true;
					}

					else
					{
						point_print(id, "%L", id, "POINT_MODEL_ALREADY");
						return;
					}
				}

				case 2:
				{
					if(num != g_status[id][5])
					{
						change_status(id, 6, num);
						update_points(id, status, 0, 0);

						point_print(id, "%L", id, "POINT_MODELS", model);
						point_print(id, "%L", id, "POINT_CURRENT", g_points[id]);

						g_cpm_ct[id] = true;
					}

					else
					{
						point_print(id, "%L", id, "POINT_MODEL_ALREADY");
						return;
					}
				}
			}
		}
	}
}

cpm_admin_handle(id, const model[])
{
	if(is_ps_on() && gb_user_connected[id])
	{
		new target = g_admin_target[id];

		static file[MAX_LENGTH + 1], name[2][MAX_LENGTH + 1];
		get_model_file(model, file, MAX_LENGTH, g_admin_team[id]);

		fm_set_user_model(target, file);
		new num = get_model_num(file, g_admin_team[id]);

		get_user_name(target, name[0], MAX_LENGTH);
		get_user_name(id, name[1], MAX_LENGTH);

		switch(g_admin_team[id])
		{
			case 1:
			{
				if(num != g_status[target][1])
				{
					change_status(target, 2, num);

					point_print(target, "%L", target, "ADMIN_MODEL_GAVE", name[1], "Terrorist", model);
					point_print(id, "%L", id, "ADMIN_MODEL_GIVEN", name[0], model);

					g_cpm_t[target] = true;
				}

				else
				{
					point_print(id, "%L", id, "ADMIN_MODEL_ALREADY", name[0]);
					return;
				}
			}

			case 2:
			{
				if(num != g_status[target][5])
				{
					change_status(target, 6, num);

					point_print(target, "%L", target, "ADMIN_MODEL_GAVE", name[1], "Counter-Terrorist", model);
					point_print(id, "%L", id, "ADMIN_MODEL_GIVEN", name[0], model);

					g_cpm_ct[target] = true;
				}

				else
				{
					point_print(id, "%L", id, "ADMIN_MODEL_ALREADY", name[0]);
					return;
				}
			}
		}
	}
}

mr_handle(id)
{
	if(is_ps_on() && gb_user_connected[id])
	{
		new status = get_pcvar_num(ps_mr_cost);

		if(g_status[id][2] > 0)
			mr_menu(id);

		else if(g_points[id] < status)
		{
			point_print(id, "%L", id, "POINT_AFFORD");
			point_print(id, "%L", id, "POINT_CHECK", g_points[id], status);
		}

		else
		{
			update_points(id, status, 0, 0);

			point_print(id, "%L", id, "POINT_MT_RS");
			point_print(id, "%L", id, "POINT_CURRENT", g_points[id]);

			change_status(id, 3, 5);
		}
	}
}

vmr_handle(id)
{
	if(is_ps_on() && gb_user_connected[id])
	{
		new status = get_pcvar_num(ps_vmr_cost);

		if(g_status[id][3] > 0)
			mr_menu(id);

		else if(g_points[id] < status)
		{
			point_print(id, "%L", id, "POINT_AFFORD");
			point_print(id, "%L", id, "POINT_CHECK", g_points[id], status);
		}

		else
		{
			update_points(id, status, 0, 0);

			point_print(id, "%L", id, "POINT_VMT_RS");
			point_print(id, "%L", id, "POINT_CURRENT", g_points[id]);

			change_status(id, 4, 5);
		}
	}
}

sam_handle(id)
{
	if(is_ps_on() && gb_user_connected[id])
	{
		new status = get_pcvar_num(ps_mv_cost);

		if(g_points[id] < status)
		{
			point_print(id, "%L", id, "POINT_AFFORD");
			point_print(id, "%L", id, "POINT_CHECK", g_points[id], status);
		}

		else
			choose_map(id);
	}
}

public sam_map(id, menu, item)
{
	if(is_ps_on() && gb_user_connected[id])
	{
		if(item == MENU_EXIT)
		{
			menu_destroy(menu);
			return 1;
		}

		static map[64];
		new access, callback;

		menu_item_getinfo(menu, item, access, map, 63, "", 0, callback);

		new status = get_pcvar_num(ps_mv_cost);

		update_points(id, status, 0, 0);

		point_print(id, "%L", id, "POINT_SAM_MAP", map);
		point_print(id, "%L", id, "POINT_CURRENT", g_points[id]);

		server_cmd("amx_votemap %s", map);
	}

	menu_destroy(menu);
	return 1;
}

public cpm_models(id, menu, item)
{
	if(item == MENU_EXIT || !gb_user_connected[id])
	{
		menu_destroy(menu);
		return 1;
	}

	new model_name[41], team[20];
	new access, callback;
	
	menu_item_getinfo(menu, item, access, model_name, 40, "", 0, callback);

	if(equal(model_name, "reset"))
	{
		switch(fm_get_user_team(id))
		{
			case FM_TEAM_T:
			{
				fm_set_user_model(id, g_HumanModels_T [random_num(0, 3)]);
				formatex(team, 19, "Terrorist");

				change_status(id, 2, 0, 1);
				g_cpm_t[id] = false;
			}

			case FM_TEAM_CT:
			{
				fm_set_user_model(id, g_HumanModels_CT[random_num(0, 3)]);
				formatex(team, 19, "Counter-Terrorist");

				change_status(id, 6, 0, 1);
				g_cpm_ct[id] = false;
			}
		}

		point_print(id, "%L", id, "POINT_MODEL_RESET", team);
	}

	else
		cpm_handle(id, model_name);
	
	menu_destroy(menu);
	return 1;
}

public cpm_admin_models(id, menu, item)
{
	if(item == MENU_EXIT || !gb_user_connected[id])
	{
		menu_destroy(menu);
		return 1;
	}
	
	new model_name[41];
	new access, callback;
	
	menu_item_getinfo(menu, item, access, model_name, 40, "", 0, callback);
	cpm_admin_handle(id, model_name);
	
	menu_destroy(menu);
	return 1;
}