/*======================================
	     [MOTD PS File]
======================================*/

format_motd_points(sBuffer[MOTD_LENGTH + 1])
{
	add(sBuffer, MOTD_LENGTH, "<html><head><meta http-equiv=^"refresh^" content=^"15^"><style>");
	add(sBuffer, MOTD_LENGTH, "body { background-color:#000000; font-family:Tahoma; font-size:10px; color:#FFFFFF; }");

	add(sBuffer, MOTD_LENGTH, ".tabel { border-style:solid; border-width:1px; border-color:#FFFFFF; font-family:Tahoma; font-size:10px; color:#FFFFFF; }");
	add(sBuffer, MOTD_LENGTH, ".header { background-color:#292929; font-family:Verdana,Tahoma; font-size:10px; color:#FFB000; font-weight:800; }");

	add(sBuffer, MOTD_LENGTH, "</style></head><body>");

	add(sBuffer, MOTD_LENGTH, "<br><br><table border=0 cellspacing=0 cellpadding=1 width=90% align=center class=tabel>");
	add(sBuffer, MOTD_LENGTH, "<tr><td class=header>ID</td><td class=header>Name</td><td class=header>Points</td></tr>");

	static key[8], points[8];
	static name[MAX_LENGTH + 1];

	for(new i = 1; i <= g_maxplayers; i++)
	{
		if(gb_user_connected[i])
		{
			num_to_str(i, key, 7);
			num_to_str(g_points[i], points, 7);

			get_user_name(i, name, MAX_LENGTH);
			html_check(name, MAX_LENGTH);

			if(get_pcvar_num(ps_lan_mode))
			{
				add(sBuffer, MOTD_LENGTH, "<tr><td>");
				add(sBuffer, MOTD_LENGTH, key);		// ID
				add(sBuffer, MOTD_LENGTH, "</td><td>");
				add(sBuffer, MOTD_LENGTH, name);	// Name
				add(sBuffer, MOTD_LENGTH, "</td><td>");
				add(sBuffer, MOTD_LENGTH, points);	// Points
			}

			else
			{
				add(sBuffer, MOTD_LENGTH, "<tr><td>");
				add(sBuffer, MOTD_LENGTH, key);		// ID
				add(sBuffer, MOTD_LENGTH, "</td><td>");
				add(sBuffer, MOTD_LENGTH, name);	// Name
				add(sBuffer, MOTD_LENGTH, "</td><td>");
				add(sBuffer, MOTD_LENGTH, points);	// Points
			}
		}
	}

	add(sBuffer, MOTD_LENGTH, "</table></body></html>");
}

format_motd_top(id, pBuffer[MOTD_LENGTH + 1])
{
	add(pBuffer, MOTD_LENGTH, "<html><head><meta http-equiv=^"refresh^" content=^"15^"><style>");
	add(pBuffer, MOTD_LENGTH, "body { background-color:#000000; font-family:Tahoma; font-size:10px; color:#FFFFFF; }");

	add(pBuffer, MOTD_LENGTH, ".tabel { border-style:solid; border-width:1px; border-color:#FFFFFF; font-family:Tahoma; font-size:10px; color:#FFFFFF; }");
	add(pBuffer, MOTD_LENGTH, ".header { background-color:#292929; font-family:Verdana,Tahoma; font-size:10px; color:#FFB000; font-weight:800; }");

	add(pBuffer, MOTD_LENGTH, "</style></head><body>");
	add(pBuffer, MOTD_LENGTH, "<br><br><table border=0 cellspacing=0 cellpadding=1 width=90% align=center class=tabel>");

	add(pBuffer, MOTD_LENGTH, "<tr><td class=header>#</td><td class=header>Name</td><td class=header>Points</td></tr>");

	#if defined SAVE_SQL
	static sql[512];
	g_ps15[id] = true;

	formatex(sql, 511, "SELECT `points`,`name` FROM `%s` ORDER BY `points` DESC LIMIT %d", g_table, TOP_NUM);
	SQL_ThreadQuery(g_SqlTuple, "sql_top_handle", sql, pBuffer, MOTD_LENGTH);

	#else

	new old[38], line = -1, parsed_num, i;

	static key[38], fdata[64], points[8], data[64];
	static name[MAX_LENGTH + 1], num[8];

	static file[128];

	if(!file[0]) _FormatVaultName(g_points_vault, file, charsmax(file));

	new vault = fopen(file, "rt");

	if(vault)
	{
		while(!feof(vault))
		{
			fgets(vault, fdata, charsmax(fdata));
			parsed_num = parse(fdata, key, charsmax(key), data, 63);

			if(parsed_num != 2) break;
			if(old[0] && equal(old, key)) continue;

			replace_all(data, 63, "#", " "); i++;
			num_to_str(i, num, 7);

			if(get_pcvar_num(ps_lan_mode))
			{
				if(parse(data, points, 7))
				{
					new size = sizeof(key) - 1;

					replace(key, size, "-PS", "");

					replace_all(key, size, "<", "&lt;");
					replace_all(key, size, ">", "&gt;");

					replace_all(key, size, "&", "&amp;");
					replace_all(key, size, "^"", "&quot;");

					add(pBuffer, MOTD_LENGTH, "<tr><td>");
					add(pBuffer, MOTD_LENGTH, num);		// Place
					add(pBuffer, MOTD_LENGTH, "</td><td>");
					add(pBuffer, MOTD_LENGTH, key);		// Name
					add(pBuffer, MOTD_LENGTH, "</td><td>");
					add(pBuffer, MOTD_LENGTH, points);	// Points
				}
			}

			else
			{
				if(parse(data, points, 7, name, MAX_LENGTH))
				{
					replace_all(name, MAX_LENGTH, "-", " ");

					new size = sizeof(name) - 1;

					replace_all(name, size, "<", "&lt;");
					replace_all(name, size, ">", "&gt;");

					replace_all(name, size, "&", "&amp;");
					replace_all(name, size, "^"", "&quot;");

					add(pBuffer, MOTD_LENGTH, "<tr><td>");
					add(pBuffer, MOTD_LENGTH, num);		// Place
					add(pBuffer, MOTD_LENGTH, "</td><td>");
					add(pBuffer, MOTD_LENGTH, name);	// Name
					add(pBuffer, MOTD_LENGTH, "</td><td>");
					add(pBuffer, MOTD_LENGTH, points);	// Points
				}
			}

			formatex(old, 37, "%s", key);
			if(++line == (TOP_NUM - 1)) break;
		}
	}

	fclose(vault);

	static title[MAX_LENGTH + 1];
	formatex(title, MAX_LENGTH, "%L", id, "POINT_PLAYER");

	add(pBuffer, MOTD_LENGTH, "</table></body></html>");
	show_motd(id, pBuffer, title);
	#endif
}

format_end_motd(id)
{
	if(is_ps_on())
	{
		static cBuffer[MOTD_LENGTH + 1], name[2][MAX_LENGTH + 1];
		static bPoints, wPoints, points;

		cBuffer = "";

		for(new i = 1; i <= g_maxplayers; i++)
		{
			if(!gb_user_connected[i]) continue;

			points = g_mPoints[i];

			if(!wPoints)
			{
				get_user_name(i, name[1], MAX_LENGTH);
				wPoints = points;
			}

			if(points >= bPoints)
			{
				get_user_name(i, name[0], MAX_LENGTH);
				bPoints = points;
			}

			if(points < wPoints)
			{
				get_user_name(i, name[1], MAX_LENGTH);
				wPoints = points;
			}
		}

		for(new i = 0; i <= 1; i++)
		{
			replace_all(name[i], MAX_LENGTH, "<", "&lt;");
			replace_all(name[i], MAX_LENGTH, ">", "&gt;");

			replace_all(name[i], MAX_LENGTH, "&", "&amp;");
			replace_all(name[i], MAX_LENGTH, "^"", "&quot;");
		}

		add(cBuffer, MOTD_LENGTH, "<head><title>Point-System End MOTD</title><style type=text/css>pre { font-family:Verdana,Tahoma; color:#FFB000; font-size: 8px; }");
		add(cBuffer, MOTD_LENGTH, "body { background:#000000; margin-left:8px; margin-top:0px; } </style></head><body><pre><h4>Point - System Winner</h4></font><font size=2 color=#FFB000>");

		new info[3][156];

		formatex(info[0], 155, "^r^nThe winner of the most points during the map is ^"%s^", He got a total amount of %d point(s)^r^n", name[0], bPoints);
		formatex(info[1], 155, "The loser of the most points during the map is ^"%s^", He got a total amount of %d point(s)^r^n^r^n", name[1], wPoints);
		formatex(info[2], 155, "You got a total amount of %d point(s) during this map, your total amount of points is now %d", g_mPoints[id], g_points[id]);

		add(cBuffer, MOTD_LENGTH, info[0]);
		add(cBuffer, MOTD_LENGTH, info[1]);
		add(cBuffer, MOTD_LENGTH, info[2]);
		add(cBuffer, MOTD_LENGTH, "</pre></body></html>");

		show_motd(id, cBuffer, "Point - System Winner");
	}
}