/*======================================
	     [Stock PS File]
======================================*/

stock bool:is_ps_on()
{
	if(!g_iPlugin || g_iPlayers < get_pcvar_num(ps_players))
		return false;
	
	return true;
}

stock log_ps(fmt[], any:...)
{
	static msg[1024];
	vformat(msg, 1023, fmt, 2);
	
	format(msg, 1023, "%s", msg);
	
	#if defined DEBUG_MODE
	if(!equali(msg, ";"))
		write_file(logdir, msg, -1);
	#endif
}


stock point_print(id, fmt[], any:...)
{
	if(id && !gb_user_connected[id] || !is_ps_on() || g_banned[id] || !get_pcvar_num(ps_message)) return 0;
	
	new MSG_TYPE, index;
	static finalmsg[192];
	
	vformat(finalmsg, 191, fmt, 3);
	format(finalmsg, 191, "^x04[PS] ^x01%s", finalmsg);
	
	if(id)
	{
		MSG_TYPE	=	MSG_ONE;
		index		=	id;
	}
	
	else
	{
		MSG_TYPE	=	MSG_ALL;
		index		=	find_players();
	}
	
	message_begin(MSG_TYPE, g_iMsgSay, _, id);
	write_byte(index);
	write_string(finalmsg);
	message_end();
	
	return 1;
}

stock point_print_spc(id, fmt[], any:...)
{
	if(id && !gb_user_connected[id]) return 0;
	
	new MSG_TYPE, index;
	static finalmsg[192];
	
	vformat(finalmsg, 191, fmt, 3);
	format(finalmsg, 191, "^x04[PS] ^x01%s", finalmsg);
	
	if(id)
	{
		MSG_TYPE	=	MSG_ONE;
		index		=	id;
	}
	
	else
	{
		MSG_TYPE	=	MSG_ALL;
		index		=	find_players();
	}
	
	message_begin(MSG_TYPE, g_iMsgSay, _, id);
	write_byte(index);
	write_string(finalmsg);
	message_end();
	
	return 1;
}

stock html_check(string[], len)
{
	replace_all_mine(string, len, "<", "(");
	replace_all_mine(string, len, ">", ")");
	replace_all_mine(string, len, "^"", "'");
}

stock sqlx_check(string[], len)
{
	replace_all_mine(string, len, "'", "");
	replace_all_mine(string, len, "`", "");
}

stock replace_all_mine(string[], len, what[], with[])
{
	do
	{
		replace(string, len, what, with);
	}

	while(containi(string, what) != -1);
}

stock fm_set_user_model(index, const modelname[])
{
	engfunc(EngFunc_SetClientKeyValue, index, engfunc(EngFunc_GetInfoKeyBuffer, index), "model", modelname);
}

stock fm_get_user_model(player, model[], len)
{
	engfunc(EngFunc_InfoKeyValue, engfunc(EngFunc_GetInfoKeyBuffer, player), "model", model, len);
}

stock get_logdir(string[], len)
{
	get_basedir(string, len);
	format(string, len, "%s/logs", string);
	
	return string;
}

stock get_systime_h()
{
	return ((get_systime() / 60) / 60);
}

stock fm_set_user_team(index, {FmTeams,_}:team, update = 1)
{
	set_pdata_int(index, OFFSET_TEAM, _:team);
	set_pev(index, pev_team, _:team);
	
	if(update)
	{
		static _msg_teaminfo; if(!_msg_teaminfo) _msg_teaminfo = get_user_msgid("TeamInfo");
		static teaminfo[][] = { "UNASSIGNED", "TERRORIST", "CT", "SPECTATOR" };
		
		message_begin(MSG_ALL, _msg_teaminfo);
		write_byte(index);
		write_string(teaminfo[_:team]);
		message_end();
	}
	
	return 1;
}

stock FmTeams:fm_get_user_team(id)
{
	return FmTeams:(get_pdata_int(id, OFFSET_TEAM));
}

stock fm_get_user_vip(id)
{
	return get_pdata_int(id, OFFSET_VIP) & PLAYER_IS_VIP;
}

stock find_players()
{
	for(new i = 1; i <= g_maxplayers; i++)
	{
		if(gb_user_connected[i])
			return i;
	}
	
	return -1;
}

stock ps_edit_admin(c_auth[], password[] = "", accessflag[], flags[] = "ce", comment[] = "", remove = 0)
{
	if(strlen(accessflag) != 1) return;

	new dir[42], file[64], auth[MAX_LENGTH + 1];
	get_configsdir(dir, 41);

	formatex(file, 63, "%s/users.ini", dir);

	if(!file_exists(file))
	{
		server_print("[PS] File ^"%s^" doesn't exist", file);
		return;
	}

	if(equali(c_auth, "STEAM_ID_LAN"))
		formatex(auth, MAX_LENGTH, "loopback");
	else
		formatex(auth, MAX_LENGTH, "%s", c_auth);

	new filedata[512], parsed_num;

	new l_auth[MAX_LENGTH + 1], l_password[64];
	new l_access[64], l_flags[64], line = -1;

	new filep = fopen(file, "rt");

	while(!feof(filep))
	{
		fgets(filep, filedata, 511); line++;

		if(!filedata[0] || equal(filedata, ";", 1))
			continue;

		parsed_num = parse(filedata, l_auth, MAX_LENGTH, l_password, 63, l_access, 63, l_flags, 63);

		if(parsed_num != 4 || containi(l_auth, ";") != -1)
			continue;

		if(equal(l_auth, auth))
		{
			if(!remove && containi(l_access, accessflag) == -1)
			{
				add(l_access, 63, accessflag);

				formatex(filedata, 511, "^"%s^" ^"%s^" ^"%s^" ^"%s^" ; %s", l_auth, l_password, l_access, l_flags, comment);
				write_file(file, filedata, line);
			}

			else if(remove && containi(l_access, accessflag) != -1)
			{
				replace_all(l_access, 63, accessflag, "");

				formatex(filedata, 511, "^"%s^" ^"%s^" ^"%s^" ^"%s^" ; %s", l_auth, l_password, l_access, l_flags, comment);
				write_file(file, filedata, line);
			}

			fclose(filep);
			return;
		}
	}

	fclose(filep);

	if(!remove)
	{
		formatex(filedata, 511, "^r^n^"%s^" ^"%s^" ^"%s^" ^"%s^" ; %s", auth, password, accessflag, flags, comment);
		if(!write_file(file, filedata)) log_amx("Failed writing admin [%s:%s]", auth, comment);
	}
}

stock bool:is_false_user(index)
{
	static info[2][MAX_LENGTH + 1];
	static hostname[MAX_LENGTH + 1];

	if(!hostname[0]) get_pcvar_string(ps_hostname, hostname, MAX_LENGTH);

	get_user_name(index, info[0], MAX_LENGTH);
	get_user_authid(index, info[1], MAX_LENGTH);

	if(!info[0][0] || !info[1][0] || equali(info[0], hostname) || g_banned[index] || is_user_bot(index))
		return true;

	return false;
}