/*======================================
	   [Variable PS File]
======================================*/

// ENUMS
enum
{
	VIP,
	CPM,
	MRS,
	VRS,
	MTD,
	CPT,
	RST
};

enum FmTeams
{
	FM_TEAM_UNASSIGNED = 0,
	FM_TEAM_T,
	FM_TEAM_CT,
	FM_TEAM_SPECTATOR
};

enum
{
	LOAD_NONE,

	LOAD_POINTS,
	LOAD_STATUS,
	LOAD_ENTRIES,
	LOAD_RANKING,

	DELETE_RESTART,
	DELETE_ENTRIES
};

// Consts
new const g_sound_status[]	=	"events/enemy_died.wav";
new const g_sound_add[]		=	"events/tutor_msg.wav";
new const g_sound_subtract[]	=	"events/friend_died.wav";

new const g_HumanModels_T [][]	=	{"sas", "gign", "gsg9", "urban"};
new const g_HumanModels_CT[][]	=	{"leet", "terror", "arctic", "guerilla"};

#if !defined SAVE_SQL
new const g_points_vault[]	=	"points_db";
new const g_status_vault[]	=	"status_db";

#else
new const g_table[]		=	"point_system";
#endif

// Miscellaneous
new HamHook:g_iHamDmg;
new HamHook:g_iHamSpawn;

new HamHook:g_iHamPost;
new HamHook:g_iHamPre;

new g_iDescription;
new g_iMsgSay;

new g_iKeyValue;
new g_iThink;

new g_iPlugin = 1;
new g_iPlayers;

new g_iMessage;
new g_iMsgAudio;

new g_iMsgDeath;
new g_iDeathID;

new g_iMsgHLTV;
new g_iHltvID;

new g_iMsgHide;
new g_iMsgCross;

// Points Earned during the map
new g_mPoints[MAX_PLAYERS + 1];

new g_info[MAX_PLAYERS + 1][MAX_LENGTH + 1];
new g_banned[MAX_PLAYERS + 1];

new g_curModel[MAX_PLAYERS + 1][MAX_LENGTH + 1];
new jump_num[MAX_PLAYERS + 1];

new g_custom_menus[MAX_CM_MENUS + 1][128];
new g_custom_menu_id[MAX_CM_MENUS + 1];

new g_custom_menus_num;
new g_intermission;

new g_played_times[MAX_PLAYERS + 1];
new do_chameleon[MAX_PLAYERS + 1];

new g_status[MAX_PLAYERS + 1][7];

new g_DoubleUsed[MAX_PLAYERS + 1];
new g_DamageUsed[MAX_PLAYERS + 1];

new g_admin_target[MAX_PLAYERS + 1];
new g_admin_team[MAX_PLAYERS + 1];

new g_points[MAX_PLAYERS + 1];
new g_maxplayers;

new filedir3[256];
new filedir4[256];

new filedir5[256];
new filedir6[256];

new menu_id_map;

new PLMDL_CT[MAX_MODELS][84];
new PLNAME_CT[MAX_MODELS][84];

new PLMDL_T[MAX_MODELS][84];
new PLNAME_T[MAX_MODELS][84];

new TotalModels_CT;
new TotalModels_T;

#if defined SAVE_SQL
new Handle:g_SqlTuple;
new g_exists[MAX_PLAYERS + 1];
new g_total[MAX_PLAYERS + 1];
#endif

#if defined DEBUG_MODE
 new logdir[256];
#endif

new g_fwd_menu_creation;
new g_fwd_menu_selection;

new g_fwd_points_pre;
new g_fwd_points_post;

new g_fwd_status_pre;
new g_fwd_status_post;

new g_fwd_dummy;

// Booleans
new bool:g_ps15[MAX_PLAYERS + 1];

new bool:g_DoubleJump[MAX_PLAYERS + 1];
new bool:g_DoubleRend[MAX_PLAYERS + 1];

new bool:g_DamageMult[MAX_PLAYERS + 1];
new bool:g_DamageRend[MAX_PLAYERS + 1];

new bool:g_Chameleon[MAX_PLAYERS + 1];
new bool:g_ChameRend[MAX_PLAYERS + 1];

new bool:gb_user_connected[MAX_PLAYERS + 1];
new bool:gb_user_alive[MAX_PLAYERS + 1];

new bool:g_round_ended[MAX_PLAYERS + 1];

new bool:gcm_shown[MAX_PLAYERS + 1];
new bool:do_jump[MAX_PLAYERS + 1];

new bool:g_banned_shwn[MAX_PLAYERS + 1];
new bool:muted[MAX_PLAYERS + 1];

new bool:g_cpm_ct[MAX_PLAYERS + 1];
new bool:g_cpm_t[MAX_PLAYERS + 1];

new bool:g_bShown;

//Pcvars
new frag_hs[33];
new frag_kl[33];

new ps_vip_cost;

new ps_dj_cost;
new ps_cpm_cost;

new ps_mr_cost;
new ps_mv_cost;

new ps_vmr_cost;
new ps_hide;

new ps_plt_points;
new ps_def_points;

new ps_tk_points;
new ps_adv_time;

new ps_sur_points;
new ps_mcy_points;

new ps_win_points_ct;
new ps_win_points_t;

new ps_time_points;
new ps_time;

new ps_mcy_stop;
new ps_map_file;

new ps_dj_rounds;
new ps_sound;

new ps_cm_cost;
new ps_cm;

new ps_vmr;
new ps_mr;

new ps_mv;
new ps_cpm;

new ps_dj;
new ps_vip;

new ps_dm;
new ps_asa;

new ps_res_points;
new ps_esc_points;

new ps_hostname;
new ps_players;

new ps_cm_rounds;
new ps_dm_rounds;

new ps_dm_cost;
new ps_game_name;

new ps_vehicle_points;
new ps_vehicle_hs;

new ps_rs_cost;
new ps_rs_weeks;
new ps_rs;

new ps_show;
new ps_tk;

new ps_lan_mode;
new ps_frags_on;

new ps_menu;
new ps_motd;

new ps_message;

#if defined SAVE_SQL
new ps_sql_fast;
#endif